-- Adjusting page for Abigail 2.30
-- 17/12/13

local abiScrollList1={}
local abiAdjHelpText={}
local abiAdjPriceEditing=0
local abiSelectedItem=0
local abiScrollTableOffset1=0
local abiAutoAdjusting=0

abiAdjHelpText[1]="Quickly adjust the price history of items"

abiAdjHelpText[5]="L-Click = Copy Name   R-Click = Edit Price Historys"
abiAdjHelpText[6]="R-Click = Stop Editing Prices"
abiAdjHelpText[7]="Enter an item name to search for"
abiAdjHelpText[8]="L-Click = Remove This High Price - Cannot Be Undone"
abiAdjHelpText[9]="Delete selected prices from an items history"
abiAdjHelpText[10]="Tick to delete this price, untick to leave it"
abiAdjHelpText[11]="Auto Adjust Price History Records"

abiAdjHelpText[15]="L-Click = Remove This Low Price - Cannot Be Undone"

function abiAutoSliderValueChanged()
	abiAutoAdjustSliderText:SetText(math.floor(abiAutoAdjustSlider:GetValue()))
end

function abiAdjustingFrame_OnLoad()
	abiAdjustingFrame:Hide()
	abiAdjustPartFrame1:SetBackdropBorderColor(1,1,1,0.5)
	abiAdjustPartFrame2:SetBackdropBorderColor(1,1,1,0.5)
	abiAdjustButton2:Disable()

	abiAdjustButton2.tooltipText="|cffffff00Delete the selected|nPrice History(s)."
	abiAdjustButton1.tooltipText="|cffffff00Left-Click to Get All Prices|nRight-Click to get Silly Prices."
	abiAutoAdjustButton.tooltipText="|cffffff00Opens the Auto-Adjust screen."
	abiAdjustBrowseButton.tooltipText="|cffffff00Search for the item|nin the text box."
	abiValuePercentButton.tooltipText="|cffffff00Search by Value or|nPercentage difference."
	abiShortenPHButton.tooltipText="|cffffff00Shorten Price History|nrecords by combining|nsimilar prices."
end



function abiAutoAdjustingFrame_OnLoad()
	abiAutoAdjustGo.tooltipText="|cffffff00If in any doubt|nbackup the Price History files first."
	abiAutoAdjustCancel.tooltipText="|cffffff00Cancels the Auto-Adjust."

end



function abiAutoAdjustSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00Will delete all highest prices that are this many times greater than the 2nd highest price. |n|nThis cannot be undone.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("35");
end



function abiAdjustSetup()
	abiAdjPriceEditing=0
	abiAutoAdjusting=0
	abiSelectedItem=0
	abiAdjustButton1:Enable()
	abiAdjustButton2:Disable()
	abiAutoAdjustFrame:Hide()
	abiAutoAdjustButton:Enable()

	for abiloop=1,15 do
		_G["abiAdjustFrame1String"..abiloop]:SetTextColor(1,0.9,0,0.9)
		_G["abiAdjustFrame1String"..abiloop]:SetFontObject("GameFontNormal")
		_G["abiAdjHigh"..abiloop]:SetFontObject("GameFontNormal")
		_G["abiAdjLow"..abiloop]:SetFontObject("GameFontNormal")
		_G["abiAdjustCheckButton"..abiloop]:SetChecked(0)
	end

	abiAH4:SetText("Price History")

	for abiloop=1,15 do
		_G["abiAdjustFrame2String"..abiloop]:Hide()
		_G["abiAdjustCheckButton"..abiloop]:Hide()
		_G["abiAdjHowmany"..abiloop]:Hide()
	end

	abiFadeAdjustScreen(1.0,0)
	abiAdjustFrameHelp(1)

	if #abiScrollList1==0 then
		abiAdjustBrowseButton:Disable()
	else
		abiAdjustBrowseButton:Enable()
	end

end



function abiDisplayAdjustScroll1Items(passed)
	local abiStart
	local abiFinish
	local abiOneToFifteen
	local abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow

	abiStart=1+abiScrollTableOffset1
	abiFinish=15+abiScrollTableOffset1

	if abiFinish>passed then
		abiFinish=passed
	end

	if abiStart<=abiFinish then

		for abidisplayloop=abiStart,abiFinish do

			abiOneToFifteen=abidisplayloop-abiStart+1
			_G["abiAdjustFrame1String"..abiOneToFifteen]:SetTextColor(1,0.9,0,0.9)
			_G["abiAdjustFrame1String"..abiOneToFifteen]:SetFontObject("GameFontNormal")

			abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow=abiDecodeAdjustList(abiScrollList1[abidisplayloop])
			_G["abiAdjustFrame1String"..abiOneToFifteen]:SetText(abiAdjName)
			_G["abiAdjustFrame1String"..abiOneToFifteen]:Show()

			_G["abiAdjHigh"..abiOneToFifteen]:SetText("|cffffffff"..abiCreateJustGoldIcon(abiAdjHigh))
			_G["abiAdjHigh"..abiOneToFifteen]:Show()

			if abiAdjLow==abiAdjHigh then
				_G["abiAdjLow"..abiOneToFifteen]:SetText("|cffffffff".."--------")

			else
				_G["abiAdjLow"..abiOneToFifteen]:SetText("|cffffffff"..abiCreateJustGoldIcon(abiAdjLow))
			end

			_G["abiAdjLow"..abiOneToFifteen]:Show()
		end

	end

end



function abiDecodeAdjustList(passed)
	local ret1,ret2,ret3,ret4=strsplit("%",passed)
	ret1=tonumber(ret1)
	ret3=tonumber(ret3)
	ret4=tonumber(ret4)
	return ret1,ret2,ret3,ret4
end	



function abiAdjustMessageFrame1_OnLeave(passed)
	AdjTip:Hide()
	BattlePetTooltip:Hide()

	if abiAutoAdjusting==1 then
		return
	end


	if abiAdjPriceEditing==1 then
		abiAdjustFrameHelp(6)
		return
	end
	
	if passed>#abiScrollList1 then
		abiAdjustFrameHelp(1)
		return
	end


	_G["abiAdjustFrame1String"..passed]:SetTextColor(1,0.9,0,0.9)
	_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormal")

	_G["abiAdjHigh"..passed]:SetFontObject("GameFontNormal")
	_G["abiAdjLow"..passed]:SetFontObject("GameFontNormal")

	abiAdjustFrameHelp(5)

	for abiloop=1,15 do
		_G["abiAdjustFrame2String"..abiloop]:Hide()
		_G["abiAdjustCheckButton"..abiloop]:Hide()
		_G["abiAdjHowmany"..abiloop]:Hide()
	end
end



function abiAdjustMessageFrame1_OnEnter(passed)

	if abiAutoAdjusting==1 then
		return
	end

	if abiAdjPriceEditing==1 then
		abiAdjustFrameHelp(6)
		return
	end
	
	if passed>#abiScrollList1 then
		abiAdjustFrameHelp(1)
		return
	end

	local abiWhich
	local abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow
	local abiHistory
	local abiLink
	local abiLinkType
	abiRealm=GetRealmName()..abiMyFaction

	_G["abiAdjustFrame1String"..passed]:SetTextColor(1,1,1,1)
	_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormalLarge")

	_G["abiAdjHigh"..passed]:SetFontObject("GameFontNormalLarge")
	_G["abiAdjLow"..passed]:SetFontObject("GameFontNormalLarge")

	abiAdjustFrameHelp(5)

	-- display the (upto) 15 price history records

	abiWhich=passed+abiScrollTableOffset1
	abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow=abiDecodeAdjustList(abiScrollList1[abiWhich])
	abiLink,_,_,_,_,_,_,_,_,_,_,_,abiHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiAdjName])
	abiDecodePriceHistory(abiHistory)

	if abiLink~= nil and abiAdjustTooltipButton1:GetText()=="Tooltip On" then

		if strmatch(abiLink, "|Hitem:") then
			local temp=abiCurrent -- this needed to stop the Adjust price historys only showing the current prices. Need full prices for this screen
			abiCurrent=0
			AdjTip:SetOwner(_G["abiAdjust1Frame"..passed],"ANCHOR_TOPLEFT")
			AdjTip:SetHyperlink(abiLink)
			abiAddTooltipData(AdjTip,"None",1)
			AdjTip:Show()
			abiCurrent=temp
		end

		if strmatch(abiLink, "|Hbattlepet:") then
			local temp=abiCurrent -- again make sure Full Price history is shown
			abiCurrent=0
			abiTempName=abiAdjName
			local _, speciesID, level, breedQuality, maxHealth, power, speed, battlePetID = strsplit(":", abiLink)
			BattlePetToolTip_Show(tonumber(speciesID), tonumber(level), tonumber(breedQuality), tonumber(maxHealth), tonumber(power), tonumber(speed), string.gsub(string.gsub(abiLink, "^(.*)%[", ""), "%](.*)$", ""))
			-- somewhat hacky - BattlePetToolTip_Show anchors to GameTooltip's anchor point, but we want to specify our own anchor
			BattlePetTooltip:ClearAllPoints()
			BattlePetTooltip:SetPoint("BOTTOMLEFT", _G["abiAdjust1Frame"..passed], "TOPLEFT", 0, 0)
			abiCurrent=temp
		end

	end

	for abiloop=1,#abiHistoryCost do
		AbigailMoneyFrame_Update(_G["abiAdjustFrame2String"..abiloop],abiHistoryCost[abiloop],0,"|cffffffff")
		_G["abiAdjHowmany"..abiloop]:SetText(abiHistorySeen[abiloop])
		_G["abiAdjustFrame2String"..abiloop]:Show()
		_G["abiAdjustCheckButton"..abiloop]:Show()
		_G["abiAdjHowmany"..abiloop]:Show()
	end

end



function abiAdjustFrame1Click(passed,button)
	local abiAdjName
	local abiHistory
	abiRealm=GetRealmName()..abiMyFaction

	if abiScrollList1[passed+abiScrollTableOffset1]==nil then
		return
	end -- just make sure the clicked part isn't empty

	_,abiAdjName,_,_=abiDecodeAdjustList(abiScrollList1[passed+abiScrollTableOffset1])
	_,_,_,_,_,_,_,_,_,_,_,_,abiHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiAdjName])

	if button=="RightButton" then

		abiAdjPriceEditing=1-abiAdjPriceEditing

		if abiAdjPriceEditing==0 then

			for abiloop=1,15 do
				_G["abiAdjustFrame1String"..abiloop]:SetTextColor(1,0.9,0,0.9)
				_G["abiAdjustFrame1String"..abiloop]:SetFontObject("GameFontNormal")
				_G["abiAdjHigh"..abiloop]:SetFontObject("GameFontNormal")
				_G["abiAdjLow"..abiloop]:SetFontObject("GameFontNormal")

				_G["abiAdjustCheckButton"..abiloop]:SetChecked(0)
			end

			abiAdjustButton2:Disable()
			_G["abiAdjustFrame1String"..passed]:SetTextColor(1,1,1,1)
			_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormalLarge")
			_G["abiAdjHigh"..passed]:SetFontObject("GameFontNormalLarge")
			_G["abiAdjLow"..passed]:SetFontObject("GameFontNormalLarge")

			abiSelectedItem=0
			abiDecodePriceHistory(abiHistory)
			abiAdjFillFrame2()
			abiAH4:SetText("Price History")
			abiFadeAdjustScreen(1.0,0)
			abiAdjustButton1:Enable()
			abiAutoAdjustButton:Enable()
			abiAdjustBrowseButton:Enable()
			abiAdjustTooltipButton1:Enable()
			abiValuePercentButton:Enable()
			abiShortenPHButton:Enable()

			abiAdjustFrameHelp(5)
		else
			abiSelectedItem=passed+abiScrollTableOffset1
			abiAH4:SetText("|cffffffff".."Price History")
			abiFadeAdjustScreen(0.5,passed)
			abiAdjustButton1:Disable()
			abiAutoAdjustButton:Disable()
			abiAdjustBrowseButton:Disable()
			abiAdjustTooltipButton1:Disable()
			abiValuePercentButton:Disable()
			abiShortenPHButton:Disable()
			abiAdjustFrameHelp(6)
		end

	end

	if button=="LeftButton" and abiAdjPriceEditing==0 then

		if IsShiftKeyDown()==1 then
			abiAdjName=abiShortenName(abiAdjName)
		end

		--Put the item name into the BrowseName field of main AH screen
		BrowseName:SetText(abiAdjName)

		--Put the item name into the Search field of this (Adjust) screen
		abiAdjBrowseName:SetText(abiAdjName)

		if (IsAddOnLoaded("Auctionator")) then
			Atr_Search_Box:SetText(abiAdjName)
		end

	end

end



function abiFadeAdjustScreen(fade,item)

	for abiloop=1,15 do

		if abiloop~=item then
			_G["abiAdjustFrame1String"..abiloop]:SetAlpha(fade)
			_G["abiAdjHigh"..abiloop]:SetAlpha(fade)
			_G["abiAdjLow"..abiloop]:SetAlpha(fade)
		end
	end
end



function abiReadPricesButtonClicked(button,passed)
	-- passed=1, actually read them. passed=0, do not read them, just remove details.
	if abiAdjPriceEditing==1 then
		return
	end

	for abiloop=1,15 do
		_G["abiAdjHigh"..abiloop]:Hide()
		_G["abiAdjLow"..abiloop]:Hide()
		_G["abiAdjustFrame1String"..abiloop]:Hide()
	end

	abiRealm=GetRealmName()..abiMyFaction
	local k,k2,v2,rat1,rat2
	local abiHistory
	local abiAdjHigh, abiAdjLow, abiAdjDiff
	abiScrollList1=table.wipe(abiScrollList1)

	for k,v in pairs(abiPriceIndex) do
		--k is the realm name

		if abiRealm==k and passed==1 then

			for k2,v2 in pairs(abiPriceIndex[k]) do
				--k2 is name field, v2 is price index field
				_,_,_,_,_,_,_,_,_,_,_,_,_,abiHistory=strsplit("%",v2)
				abiDecodePriceHistory(abiHistory)
				abiAdjHigh=abiHistoryCost[1]
				abiAdjLow=abiHistoryCost[#abiHistoryCost]
				if abiValuePercentButton:GetText()=="By Value" then
					abiAdjDiff=abiAdjHigh-abiAdjLow

					if abiAdjDiff>9999 and button=="LeftButton" or -- more than 99 silver 99 copper
					abiAdjHigh>abiAdjLow*15 and button=="RightButton" and abiAdjDiff>39999 then

						abiScrollList1[#abiScrollList1+1]=abiMakeFullPrice(abiAdjDiff).."%"..k2.."%"..abiAdjHigh.."%"..abiAdjLow
					end
				else
					abiAdjDiff=math.floor(abiAdjHigh/abiAdjLow)
					if button=="LeftButton" and #abiHistoryCost>1 or
					button=="RightButton" and abiAdjDiff>50 then
						abiScrollList1[#abiScrollList1+1]=abiMakeFullPrice(abiAdjDiff).."%"..k2.."%"..abiAdjHigh.."%"..abiAdjLow
					end

				end

			end

		end

		table.sort(abiScrollList1,abiHighLow)
		abiAdjustScroll1Update()
		abiDisplayAdjustScroll1Items(#abiScrollList1)
	end

	abiAdjustBrowseButton:Enable()

end



function abiAdjustScroll1Update()

	if #abiScrollList1~=0 then

		FauxScrollFrame_Update(abiAdjustScrollFrame1,#abiScrollList1,15,15)
		-- #abiScrollList1 is max entries, 15 is number of lines, 15 is pixel height of each line
		abiScrollTableOffset1=FauxScrollFrame_GetOffset(abiAdjustScrollFrame1)
		abiDisplayAdjustScroll1Items(#abiScrollList1)
		abiAdjustScrollFrame1:Show()

		if abiAdjPriceEditing==1 then

			abiFadeAdjustScreen(1.0,0)
			abiAdjustButton1:Enable()
			abiAdjustButton2:Disable()
			abiAH4:SetText("Price History")

			for abiloop=1,15 do

				_G["abiAdjustFrame1String"..abiloop]:SetTextColor(1,0.9,0,0.9)
				_G["abiAdjustFrame1String"..abiloop]:SetFontObject("GameFontNormal")

				_G["abiAdjHigh"..abiloop]:SetFontObject("GameFontNormal")
				_G["abiAdjLow"..abiloop]:SetFontObject("GameFontNormal")

				_G["abiAdjustFrame2String"..abiloop]:Hide()
				_G["abiAdjustCheckButton"..abiloop]:Hide()
				_G["abiAdjHowmany"..abiloop]:Hide()

			end
		end


		abiAdjPriceEditing=0
	end

end



function abiAdjustFrameHelp(passed)
	if abiAutoAdjusting==1 then
		if passed~=12 and passed~=13 and passed~=14 then
			passed=11
		end
		abiAdjustHelp:SetText("|cffffffff"..abiAdjHelpText[passed])
		return
	end

	if #abiScrollList1==0 and passed~=2 then
		abiAdjustHelp:SetText("|cffffffff"..abiAdjHelpText[1])
		return
	end
	
	if abiAdjPriceEditing==1 and passed==1 then
		abiAdjustHelp:SetText("|cffffffff"..abiAdjHelpText[9])
		return
	end

	abiAdjustHelp:SetText("|cffffffff"..abiAdjHelpText[passed])
end



function abiAdjustButton2_OnClick()
	local abiCanDoThis=0

	for abiloop=1,#abiHistoryCost do

		if _G["abiAdjustCheckButton"..abiloop]:GetChecked()~=1 then
			abiCanDoThis=1
		end
	end

	if abiCanDoThis==0 then
		return -- will not allow ALL the prices to be removed - must have at least one left.
	end

	local abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow
	local abiT1,abiT2,abiT3,abiT4,abiT5,abiT6,abiT7,abiT8,abiT9,abiHistory
	local abitemp
	abiRealm=GetRealmName()..abiMyFaction
	abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow=abiDecodeAdjustList(abiScrollList1[abiSelectedItem])
	abiT1,abiT2,abiT3,abiT4,abiT5,abiT6,abiT7,abiT8,abiT9,abiTimeStamp,abiRecentHigh,abiRecentLow,abiHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiAdjName])

	for abiloop=#abiHistoryCost,1,-1 do

		if _G["abiAdjustCheckButton"..abiloop]:GetChecked()==1 then
			t=table.remove(abiHistoryCost,abiloop)
			t=table.remove(abiHistorySeen,abiloop)
			_G["abiAdjustCheckButton"..abiloop]:SetChecked(0)
		end

	end

	abiHistory=abiEncodePriceHistory()
	abiPriceIndex[abiRealm][abiAdjName]=abiT1.."%"..abiT2.."%"..abiT3.."%"..abiT4.."%"..abiT5.."%"..abiT6.."%"..abiT7.."%"..abiT8.."%"..abiT9.."%"..abiTimeStamp.."%"..abiRecentHigh.."%"..abiRecentLow.."%x%"..abiHistory
	abiDecodePriceHistory(abiHistory)
	abiAdjFillFrame2()
	abiAdjustButton2:Disable()

	-- now put the new prices on the main part of the screen

	abiAdjHigh=abiHistoryCost[1]
	abiAdjLow=abiHistoryCost[#abiHistoryCost]
	abiAdjDiff=abiAdjHigh-abiAdjLow
	abiScrollList1[abiSelectedItem]=abiAdjDiff.."%"..abiAdjName.."%"..abiAdjHigh.."%"..abiAdjLow
	abitemp=abiSelectedItem-abiScrollTableOffset1
	_G["abiAdjHigh"..abitemp]:SetText("|cffffffff"..abiCreateJustGoldIcon(abiAdjHigh))

	if abiAdjLow==abiAdjHigh then
		_G["abiAdjLow"..abitemp]:SetText("|cffffffff".."--------")
	else
		_G["abiAdjLow"..abitemp]:SetText("|cffffffff"..abiCreateJustGoldIcon(abiAdjLow))
	end

end



function abiAdjFillFrame2()
	abiAdjEmptyFrame2()

	for abiloop=1,#abiHistoryCost do
		AbigailMoneyFrame_Update(_G["abiAdjustFrame2String"..abiloop],abiHistoryCost[abiloop],0,"|cffffffff")
		_G["abiAdjHowmany"..abiloop]:SetText(abiHistorySeen[abiloop])
		_G["abiAdjustFrame2String"..abiloop]:Show()
		_G["abiAdjustCheckButton"..abiloop]:Show()
		_G["abiAdjHowmany"..abiloop]:Show()
	end

end



function abiAdjEmptyFrame2()

	for abiloop=1,15 do
		_G["abiAdjustFrame2String"..abiloop]:Hide()
		_G["abiAdjustCheckButton"..abiloop]:Hide()
		_G["abiAdjHowmany"..abiloop]:Hide()
	end
end



function abiAdjustingMakeHeaders()
	CreateFrame("Button","abiAH1",abiAdjustingFrame,"AbigailButtonTemplate")
	abiAH1:SetWidth(325)
	abiAH1:SetHeight(20)
	abiAH1:SetPoint("TOPLEFT",AuctionFrame,"TOP",-347,-54)
	abiAH1:SetText("Item Name")
	abiAH1.tooltipText="|cffffff00Item you can adjust the prices for."

	CreateFrame("Button","abiAH2",abiAdjustingFrame,"AbigailButtonTemplate")
	abiAH2:SetWidth(100)
	abiAH2:SetHeight(20)
	abiAH2:SetPoint("TOPLEFT",AuctionFrame,"TOP",-24,-54)
	abiAH2:SetText("Hi - Price")
	abiAH2.tooltipText="|cffffff00The highest price for this item|nin the price history file.|n|nLeft Click a high price|nto remove it.|n|cffff0000This Cannot Be Undone"

	CreateFrame("Button","abiAH3",abiAdjustingFrame,"AbigailButtonTemplate")
	abiAH3:SetWidth(100)
	abiAH3:SetHeight(20)
	abiAH3:SetPoint("TOPLEFT",AuctionFrame,"TOP",74,-54)
	abiAH3:SetText("Low - Price")
	abiAH3.tooltipText="|cffffff00The lowest price for this item|nin the price history file.|n|nLeft Click a low price|nto remove it.|n|cffff0000This Cannot Be Undone"

	CreateFrame("Button","abiAH4",abiAdjustingFrame,"AbigailButtonTemplate")
	abiAH4:SetWidth(206)
	abiAH4:SetHeight(20)
	abiAH4:SetPoint("TOPLEFT",AuctionFrame,"TOP",186,-54)
	abiAH4:SetText("Price History")
	abiAH4.tooltipText="|cffffff00The price history records for|nthe highlighted item."
end


function abiAdjustingMakeFrames()

	for abiloop=1,15 do

		framename="abiAdjHigh"..abiloop
		f=abiAdjustPartFrame1:CreateFontString(framename)
		f:SetPoint("TOPLEFT",abiAdjustPartFrame1,"TOPLEFT",341,6-(abiloop*20))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(100)
		f:SetHeight(20)
		f:SetJustifyH("RIGHT")
		f:SetText(" ")
		f:Hide()

		framename="abiAdjLow"..abiloop
		f=abiAdjustPartFrame1:CreateFontString(framename)
		f:SetPoint("TOPLEFT",abiAdjustPartFrame1,"TOPLEFT",441,6-(abiloop*20))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(100)
		f:SetHeight(20)
		f:SetJustifyH("RIGHT")
		f:SetText(" ")
		f:Hide()

		framename="abiAdjustFrame2String"..abiloop
		f=CreateFrame("Frame",framename,abiAdjustPartFrame2,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiAdjustPartFrame2,"TOPLEFT",25,6-(abiloop*20))
		f:SetScript("OnEnter",abiShowHistoryHelp)
		f:Hide()

		checkname="abiAdjustCheckButton"..abiloop
		f=CreateFrame("CheckButton",checkname,abiAdjustPartFrame2,"UICheckButtonTemplate")
		f:SetPoint("TOPLEFT",abiAdjustPartFrame2,"TOPLEFT",153,6-(abiloop*20))
		f:SetWidth(20)
		f:SetHeight(20)
		f:SetScript("OnClick",abiAdjustCBClicked)
		f:SetScript("OnEnter",abiShowCheckButtonHelp)
		f:SetScript("OnLeave",abiUnShowCheckButtonHelp)
		f:Hide()

		framename="abiAdjHowmany"..abiloop
		f=abiAdjustPartFrame2:CreateFontString(framename)
		f:SetPoint("TOPLEFT",abiAdjustPartFrame2,"TOPLEFT",148,6-(abiloop*20))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(60)
		f:SetHeight(20)
		f:SetJustifyH("RIGHT")
		f:SetText(" ")
		f:Hide()

	end

	-- Make a tooltip
	CreateFrame("GameTooltip","AdjTip",abiAdjustingFrame,"GameTooltipTemplate")

end



function abiShowCheckButtonHelp()
	abiAdjustFrameHelp(10)
end



function abiUnShowCheckButtonHelp()
	abiAdjustFrameHelp(9)
end



function abiAdjustCBClicked()
	abiAdjustButton2:Disable()

	for abiloop=1,15 do

		if _G["abiAdjustCheckButton"..abiloop]:GetChecked()==1 then
			abiAdjustButton2:Enable()
			return
		end

	end
end



function abiAdjustBrowseButton_OnClick()
	local abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow
	local abiSearchFor=abiAdjBrowseName:GetText()
	abiSearchFor=string.upper(abiSearchFor)
	local abiswap
	local abiswapcount=1

	if #abiScrollList1==0 or #abiScrollList1==nil or abiSearchFor=="" then
		return
	end

	for abiloop=2,#abiScrollList1 do

		abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow=abiDecodeAdjustList(abiScrollList1[abiloop])
		abiAdjName=string.upper(abiAdjName)

		if string.sub(abiAdjName,1,#abiSearchFor)==abiSearchFor then
			abiswap=abiScrollList1[abiswapcount]
			abiScrollList1[abiswapcount]=abiScrollList1[abiloop]
			abiScrollList1[abiloop]=abiswap
			abiswapcount=abiswapcount+1

			abiAdjustScrollFrame1:SetVerticalScroll(0)
			abiDisplayAdjustScroll1Items(#abiScrollList1)
		end

	end
end



function abiAdjustTooltipButton1_OnClick()

	if abiAdjustTooltipButton1:GetText()=="Tooltip On" then
		abiAdjustTooltipButton1:SetText("Tooltip Off")
	else
		abiAdjustTooltipButton1:SetText("Tooltip On")
	end
end



function abiAdjustPartFrame1Click()

	if abiAdjPriceEditing==1 then

		for abiloop=1,15 do
			_G["abiAdjustFrame1String"..abiloop]:SetTextColor(1,0.9,0,0.9)
			_G["abiAdjustFrame1String"..abiloop]:SetFontObject("GameFontNormal")
			_G["abiAdjHigh"..abiloop]:SetFontObject("GameFontNormal")
			_G["abiAdjLow"..abiloop]:SetFontObject("GameFontNormal")
			_G["abiAdjustCheckButton"..abiloop]:SetChecked(0)
		end

		abiAdjustButton2:Disable()

		abiSelectedItem=0

		abiAH4:SetText("Price History")
		abiFadeAdjustScreen(1.0,0)
		abiAdjustButton1:Enable()
		abiAdjPriceEditing=0

	end

end



function abiAdjustPriceClick(passed,button,highlow)
	if passed>#abiScrollList1 then
		return
	end
	
	if abiAdjPriceEditing==1 then
		abiAdjustFrame1Click(passed,button)
		return
	end
	
	if #abiHistoryCost<2 then
		return
	end

	local t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12
	local abiWhich
	local abiAdjDiff2,abiAdjName2,abiAdjHigh2,abiAdjLow2

	-- if gets here - the abiDecodeHistory has already been done

	if button~="LeftButton" then
		return
	end
	if highlow==0 then
		table.remove(abiHistoryCost) -- last element
		table.remove(abiHistorySeen) -- last element
	else
		table.remove(abiHistoryCost,1) -- 1st element
		table.remove(abiHistorySeen,1) -- 1st element
	end



	abiWhich=passed+abiScrollTableOffset1
	abiAdjDiff2,abiAdjName2,abiAdjHigh2,abiAdjLow2=abiDecodeAdjustList(abiScrollList1[abiWhich])
	t1,t2,t3,t4,t5,t6,t7,t8,t9,abiTimeStamp,t11,t12,_=abiDecodeIndex(abiPriceIndex[abiRealm][abiAdjName2])
	t10=abiEncodePriceHistory()
	abiPriceIndex[abiRealm][abiAdjName2]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..t8.."%"..t9.."%"..abiTimeStamp.."%"..t11.."%"..t12.."%x%"..t10

	abiAdjHigh2=abiHistoryCost[1]
	abiAdjLow2=abiHistoryCost[#abiHistoryCost]
	abiAdjDiff2=abiAdjHigh2-abiAdjLow2

	if abiAdjDiff2>9999 then -- more than 99 silver 99 copper
		abiScrollList1[abiWhich]=abiMakeFullPrice(abiAdjDiff2).."%"..abiAdjName2.."%"..abiAdjHigh2.."%"..abiAdjLow2
	else
		abiScrollList1[abiWhich]=abiMakeFullPrice(abiAdjDiff2).."%"..abiAdjName2.."%"..abiAdjHigh2.."%"..abiAdjHigh2
	end
	
	-- now get the new abiHistoryCost and abiHistorySeen
	abiAdjDiff2,abiAdjName2,abiAdjHigh2,abiAdjLow2=abiDecodeAdjustList(abiScrollList1[abiWhich])
	abiDisplayAdjustScroll1Items(#abiScrollList1)

	if abiAdjHigh2==abiAdjLow2 then
		_G["abiAdjustFrame1String"..passed]:SetTextColor(1,0,0,1)
		_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormalLarge")
	else
		_G["abiAdjustFrame1String"..passed]:SetTextColor(0,1,0,1)
		_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormalLarge")
	end

	_,_,_,_,_,_,_,_,_,_,_,_,t10=abiDecodeIndex(abiPriceIndex[abiRealm][abiAdjName2])
	abiDecodePriceHistory(t10) -- gets new costs and times-seen
	abiAdjFillFrame2()

end



function abiAdjustPriceFrame_OnEnter(passed,highlow)
	local t

	if abiAdjPriceEditing==1 or abiAutoAdjusting==1 then
		abiAdjustFrameHelp(6)
		return
	end

	if passed>#abiScrollList1 then
		abiAdjustFrameHelp(1)
		return
	end

	if highlow=="High" then
		abiAdjustFrameHelp(8)
	else
		abiAdjustFrameHelp(15)
	end

	_G["abiAdjustFrame1String"..passed]:SetTextColor(0,1,0,1) -- highlight the name green
	_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormalLarge")

	_G["abiAdjHigh"..passed]:SetFontObject("GameFontNormalLarge")
	_G["abiAdjLow"..passed]:SetFontObject("GameFontNormalLarge")


	-- display the (upto) 15 price history records

	abiWhich=passed+abiScrollTableOffset1

	if abiScrollList1[abiWhich]~=nil then
		abiAdjDiff,abiAdjName,abiAdjHigh,abiAdjLow=abiDecodeAdjustList(abiScrollList1[abiWhich])
		abiLink,_,_,_,_,_,_,_,_,_,_,_,abiHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiAdjName])
		abiDecodePriceHistory(abiHistory)

		if abiAdjHigh==abiAdjLow then -- make the name red if it cannot be altered (only one price)
			_G["abiAdjustFrame1String"..passed]:SetTextColor(1,0,0,1)
		end

		for abiloop=1,#abiHistoryCost do
			AbigailMoneyFrame_Update(_G["abiAdjustFrame2String"..abiloop],abiHistoryCost[abiloop],0,"|cffffffff")
			_G["abiAdjHowmany"..abiloop]:SetText(abiHistorySeen[abiloop])
			_G["abiAdjustFrame2String"..abiloop]:Show()
			_G["abiAdjustCheckButton"..abiloop]:Show()
			_G["abiAdjHowmany"..abiloop]:Show()
		end

	end

end



function abiAdjustPriceFrame_OnLeave(passed)

	if abiAutoAdjusting==1 then
		return
	end

	if abiAdjPriceEditing==1 then
		abiAdjustFrameHelp(6)
		return
	end
	
	if passed>#abiScrollList1 then
		abiAdjustFrameHelp(1)
		return
	end

	abiAdjustFrameHelp(1)
	_G["abiAdjustFrame1String"..passed]:SetTextColor(1,0.9,0,0.9)
	_G["abiAdjustFrame1String"..passed]:SetFontObject("GameFontNormal")

	_G["abiAdjHigh"..passed]:SetFontObject("GameFontNormal")
	_G["abiAdjLow"..passed]:SetFontObject("GameFontNormal")

	for abiloop=1,15 do
		_G["abiAdjustFrame2String"..abiloop]:Hide()
		_G["abiAdjustCheckButton"..abiloop]:Hide()
		_G["abiAdjHowmany"..abiloop]:Hide()
	end

end



function abiShowHistoryHelp()
	abiAdjustFrameHelp(9)
end



function abiAutoAdjustButton_OnClick()
	abiAutoAdjusting=1
	abiAutoAdjustFrame:Show()
	abiAutoAdjustButton:Disable()
	abiAdjustButton1:Disable()
	abiAdjustBrowseButton:Disable()
	abiFadeAdjustScreen(0.5,0)
end



function abiAutoAdjustGoButton_OnClick()

	abiRealm=GetRealmName()..abiMyFaction
	local k,k2,v,v2
	local abiHistory
	local abiMultiply=abiAutoAdjustSlider:GetValue()
	local abiRemoved=0
	local t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13

	for k,v in pairs(abiPriceIndex) do
		--k is the realm name

		if abiRealm==k then -- only do this for this realm

			for k2,v2 in pairs(abiPriceIndex[k]) do

				--k2 is name field, v2 is price index field
				t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,abiHistory=strsplit("%",v2)
				abiDecodePriceHistory(abiHistory)

				if #abiHistoryCost>1 and (abiHistoryCost[1]>abiHistoryCost[2]*abiMultiply) then

					t=table.remove(abiHistoryCost,1)
					t=table.remove(abiHistorySeen,1)
					abiRemoved=abiRemoved+1
						
					abiHistory=abiEncodePriceHistory()
					abiPriceIndex[k][k2]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..t8.."%"..t9.."%"..t10.."%"..t11.."%"..t12.."%"..t13.."%"..abiHistory
				end

			end

		end

	end

	print("A total of "..abiRemoved.." records have been adjusted.")
	abiAutoAdjustCancelButton_OnClick() -- use this to reset the screen
	abiReadPricesButtonClicked("LeftButton",1) -- get the new records, and have them displayed on the screen
end



function abiAutoAdjustCancelButton_OnClick()
	abiAutoAdjusting=0
	abiAutoAdjustFrame:Hide()
	abiAutoAdjustButton:Enable()
	abiAdjustButton1:Enable()

	if #abiScrollList1~=0 then
		abiAdjustBrowseButton:Enable()
	end

	abiFadeAdjustScreen(1,0)
end

function abiValuePercentButton_OnClick()
	if abiValuePercentButton:GetText()=="By Value" then
		abiValuePercentButton:SetText("By Percent")
	else
		abiValuePercentButton:SetText("By Value")
	end
end



function abiShortenPHButton_OnClick()
	local abiTempPrices={}
	local abiTempNumbers={}
	local t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,abiHistory
	local abiPercent
	local abiShortened=0
	local abiShortenedTemp=0
	for k,v in pairs(abiPriceIndex) do
	--k is the realm name

		for k2,v2 in pairs(abiPriceIndex[k]) do
		--k2 is name field, v2 is price index field
			t1,t2,t3,t4,t5,t6,t7,t8,t9,t10,t11,t12,t13,abiHistory=strsplit("%",v2)
			abiDecodePriceHistory(abiHistory)
			abiShortenedTemp=0

			if #abiHistoryCost>1 then
				abiTempPrices=table.wipe(abiTempPrices)
				abiTempNumbers=table.wipe(abiTempNumbers)

				for abiloop=1,#abiHistoryCost-1 do
					abiPercent=math.floor(abiHistoryCost[abiloop]*15/100)
					if ((abiHistoryCost[abiloop]-abiPercent)<abiHistoryCost[abiloop+1]) and abiHistoryCost[abiloop]>0 then
						abiTempPrices[#abiTempPrices+1]=math.floor((abiHistoryCost[abiloop]+abiHistoryCost[abiloop+1])/2)
						abiTempNumbers[#abiTempNumbers+1]=abiHistorySeen[abiloop]+abiHistorySeen[abiloop+1]
						abiHistoryCost[abiloop+1]=0
						abiHistorySeen[abiloop+1]=0
						abiShortenedTemp=1
					else
						abiTempPrices[#abiTempPrices+1]=abiHistoryCost[abiloop]
						abiTempNumbers[#abiTempNumbers+1]=abiHistorySeen[abiloop]
						if abiloop==#abiHistoryCost-1 then
							abiTempPrices[#abiTempPrices+1]=abiHistoryCost[abiloop+1]
							abiTempNumbers[#abiTempNumbers+1]=abiHistorySeen[abiloop+1]
						end				
					end
				end

				abiHistoryCost=table.wipe(abiHistoryCost)
				abiHistorySeen=table.wipe(abiHistorySeen)

				for abiloop=1,#abiTempPrices do
					if abiTempPrices[abiloop]~=0 then
						abiHistoryCost[#abiHistoryCost+1]=abiTempPrices[abiloop]
						abiHistorySeen[#abiHistorySeen+1]=abiTempNumbers[abiloop]
					end
				end

			end
			abiShortened=abiShortened+abiShortenedTemp
			abiHistory=abiEncodePriceHistory()

			abiPriceIndex[k][k2]=t1.."%"..t2.."%"..t3.."%"..t4.."%"..t5.."%"..t6.."%"..t7.."%"..t8.."%"..t9.."%"..t10.."%"..t11.."%"..t12.."%"..t13.."%"..abiHistory
		end
	end
	print("A total of "..abiShortened.." items have had their prices adjusted.")
end