--Functions for Abigail 2.30
--17/12/13


function abiMake5(t)
	t=tostring(t)
	t=string.rep("0",5-#t)..t
	return t
end



function abiMakeFullPrice(passed)
	local p
	p=tostring(passed)
	-- convert p to a number string ie 0000001234
	p=string.rep("0",10-#p)..p
	return p
end



function abiPutTextBackToNormal()

	for abiloop=1,13 do
		_G["abiFS"..abiloop.."1"]:SetTextColor(1,0.9,0,0.9)
		_G["abiFS"..abiloop.."1"]:SetFontObject("GameFontNormal")
	end

end



function abiDecodeItemLink(t)
	_,_,_,t,_=strsplit("|",t)
	t=string.sub(t,3,-2)
	return t
end



function abiDecodeRatio(t)
	local ret1,ret2
	--Sold Number, Auctioned Number
	ret1,ret2=strsplit(":",t)
	ret1=tonumber(ret1)
	ret2=tonumber(ret2)
	return ret1,ret2
end



function abiShortenName(ret1)
	local temp1
	temp1,_=string.find(ret1," of ")

	if temp1~=nil then
		ret1=string.sub(ret1,1,temp1)
		return ret1
	end

	temp1,_=string.find(ret1,"-")

	if temp1~=nil then
		ret1=string.sub(ret1,1,temp1-2)
	end

	return ret1
end



function abiDecodeSellAllTable(passed)
	local ret1,ret2,ret3,ret4,ret5=strsplit("%",passed)
	ret2=tonumber(ret2)
	ret3=tonumber(ret3)
	ret4=tonumber(ret4)
	return ret1,ret2,ret3,ret4,ret5
end



function abiUpdatePriceHistory(t,updown)
	local abiFoundPlace=0

	for l=1,#abiHistoryCost do

		if t>=(abiHistoryCost[l]*0.9) and t<=(abiHistoryCost[l]*1.1) then

			if abiHistorySeen[l]+updown~=0 then
				abiHistorySeen[l]=abiHistorySeen[l]+updown
			end

			return
		end

	end

	if updown==-1 then
		return
	end


	--need to check if 15 price records already kept for this item.
	--if not, put price in the next available space.

	if #abiHistoryCost<15 then
		abiHistoryCost[#abiHistoryCost+1]=t
		abiHistorySeen[#abiHistorySeen+1]=1
		return
	end

	-- OR, no spaces available, so slot inbetween nearest prices

	for loop=2,15 do
		if t<abiHistoryCost[loop-1] and t>abiHistoryCost[loop] then
			abiFoundPlace=loop
		end
	end

	if abiFoundPlace~=0 then
		table.insert(abiHistoryCost,abiFoundPlace,t)
		table.insert(abiHistorySeen,abiFoundPlace,1)

		if abiFoundPlace>7 then
			table.remove(abiHistoryCost,1)
			table.remove(abiHistorySeen,1)
		else
			table.remove(abiHistoryCost,16)
			table.remove(abiHistorySeen,16)
		end

		return
	end

	if t>abiHistoryCost[1] then
		table.insert(abiHistoryCost,1,t)
		table.insert(abiHistorySeen,1,1)
		table.remove(abiHistoryCost,16)
		table.remove(abiHistorySeen,16)
		return
	end

	if t<abiHistoryCost[15] then
		abiHistoryCost[16]=t
		abiHistorySeen[16]=1
		table.remove(abiHistoryCost,1)
		table.remove(abiHistorySeen,1)
	end

end



function abiDecodeImage(t)
	local ret1,ret2,ret3,ret4,ret5,ret6
	--Name, Stack, Price, ItemLink,BidTime,BidAmount
	ret1,ret2,ret3,ret4,ret5,ret6=strsplit("%",t)
	ret2=tonumber(ret2)
	ret3=tonumber(ret3)
	ret5=tonumber(ret5)
	ret6=tonumber(ret6)
	return ret1,ret2,ret3,ret4,ret5,ret6
end



function abiDecodeIndex(t)
	local ret1,ret2,ret3,ret4,ret5,ret6,ret7,ret8,ret9,ret10,ret11,ret12,ret13
	--Link,BHigh,Blow,Shigh,Slow,RecentSold,RecentBought,Ratio,Seen,TimeStamp,RecentHigh,RecentLow,_,PriceHistory
	ret1,ret2,ret3,ret4,ret5,ret6,ret7,ret8,ret9,ret10,ret11,ret12,_,ret13=strsplit("%",t)
	ret2=tonumber(ret2)
	ret3=tonumber(ret3)
	ret4=tonumber(ret4)
	ret5=tonumber(ret5)
	ret10=tonumber(ret10)
	--ret11=tonumber(ret11)
	--ret12=tonumber(ret12)
	return ret1,ret2,ret3,ret4,ret5,ret6,ret7,ret8,ret9,ret10,ret11,ret12,ret13
end



function abiDecodePriceHistory(t)
	abiHistoryCost=table.wipe(abiHistoryCost)
	abiHistorySeen=table.wipe(abiHistorySeen)

	for k,v in string.gmatch(t,"(%w+)*(%w+)") do
		abiHistoryCost[#abiHistoryCost+1]=tonumber(k)
		abiHistorySeen[#abiHistorySeen+1]=tonumber(v)
	end

end



function abiEncodePriceHistory()
	local ret1=""
	local temptable={}

	for l=1,#abiHistoryCost do
		if abiHistoryCost[l]>0 then
			--temptable[l]=abiMakeFullPrice(abiHistoryCost[l]).."*"..tostring(abiHistorySeen[l])
			temptable[#temptable+1]=abiMakeFullPrice(abiHistoryCost[l]).."*"..tostring(abiHistorySeen[l])
		end
	end

	table.sort(temptable,abiHighLow)

	for l=1,#temptable do
		ret1=ret1..temptable[l]

		if l~=#temptable then 
			ret1=ret1..","
		end

	end
	return ret1
end



function abiFindHighestPrice()
	local t=0
	local v=0

	for k=1,#abiHistoryCost do

		if abiHistoryCost[k]>v then
			v=abiHistoryCost[k]
			t=k
		end

	end

	k=abiHistoryCost[1]
	abiHistoryCost[1]=abiHistoryCost[t]
	abiHistoryCost[t]=k
	k=abiHistorySeen[1]
	abiHistorySeen[1]=abiHistorySeen[t]
	abiHistorySeen[t]=k
end



function abiFindAveragePrice()
	-- returns abiAverage
	--should have already used abiDecodePriceHistory to get all details into History Cost and Seen arrays
	local abiAverage=0
	local abiSeen=0

	for l=1,#abiHistoryCost do
		abiAverage=abiAverage+(abiHistoryCost[l]*abiHistorySeen[l])
		abiSeen=abiSeen+abiHistorySeen[l]
	end

	abiAverage=math.floor(abiAverage/abiSeen)
	return abiAverage
end



function abiFindMeanPrice()
	-- returns abiMean
	--should have already used abiDecodePriceHistory to get all details into History Cost and Seen arrays
	local abiMean=0

	for l=1,#abiHistoryCost do
		abiMean=abiMean+abiHistoryCost[l]
	end

	abiMean=math.floor(abiMean/#abiHistoryCost)
	return abiMean
end



function abiClearExtraInformation()

	for abiloop=1,15 do
		_G["abiPS"..abiloop]:Hide()
	end

end



function abiDecodePriceDays(passed)
	-- returns Price,Days
	local abiPrice,abiDays=strsplit(":",passed)
	abiPrice=tonumber(abiPrice)
	abiDays=time()-tonumber(abiDays)
	abiDays=math.floor(abiDays/86400) --seconds per day

	if abiDays>99 then
		abiDays=99
	end

	return abiPrice,abiDays
end



function abiCreatePriceString(passed)
	local abiGold=floor(passed/10000)
	local abiSilver=string.format("%02d",floor((passed-(abiGold*10000))/100))
	local abiCopper=string.format("%02d",mod(passed,100))
	return abiGold.."g, "..abiSilver.."s, "..abiCopper.."c"
end



function abiCreatePriceStringIcons(passed,prefix)
	local abiGold=floor(passed/10000)
	local abiSilver=floor((passed-(abiGold*10000))/100)
	local abiCopper=mod(passed,100)

	ret1=format(GOLD_AMOUNT_TEXTURE,abiGold,0,0).."  "

	if abiSilver<10 then
		ret1=ret1.."0"
	end

	ret1=ret1..format(SILVER_AMOUNT_TEXTURE,abiSilver,0,0).."  "

	if abiCopper<10 then
		ret1=ret1.."0"
	end

	ret1=ret1..format(COPPER_AMOUNT_TEXTURE,abiCopper,0,0)

	if prefix~=0 then
		ret1=prefix.." "..ret1
	end

	return ret1
end	



function abiCreateJustGoldIcon(passed)
	local abiGold=floor(passed/10000)
	return format(GOLD_AMOUNT_TEXTURE,abiGold,0,0)
end



function abiMakeTheHeaders()
	local extratext=" - Full Pricing Data"

	if abiCurrent==1 then
		extratext=" - Current Pricing Data"
	end
	
	CreateFrame("Button","abiTH1",abiDataFrame,"AbigailButtonTemplate")
	abiTH1:SetWidth(264)
	abiTH1:SetHeight(20)
	abiTH1:SetPoint("TOPLEFT",AuctionFrame,"TOP",-330,-54)
	abiTH1:SetText("Items For Sale")

	CreateFrame("Button","abiTH2",abiDataFrame,"AbigailButtonTemplate")
	abiTH2:SetWidth(130)
	abiTH2:SetHeight(20)
	abiTH2:SetScript("OnClick",abiSortByBuyout)
	abiTH2:SetPoint("TOPLEFT",AuctionFrame,"TOP",-69,-54)
	abiTH2:SetText("Buyout")

	CreateFrame("Button","abiTH3",abiDataFrame,"AbigailButtonTemplate")
	abiTH3:SetWidth(130)
	abiTH3:SetHeight(20)
	abiTH3:SetPoint("TOPLEFT",AuctionFrame,"TOP",59,-54)
	abiTH3:SetText("Average")

	CreateFrame("Button","abiTH4",abiDataFrame,"AbigailButtonTemplate")
	abiTH4:SetWidth(130)
	abiTH4:SetHeight(20)
	abiTH4:SetScript("OnClick",abiSortByProfit)
	abiTH4:SetPoint("TOPLEFT",AuctionFrame,"TOP",188,-54)
	abiTH4:SetText("Profit")
	
	CreateFrame("Button","abiTH5",abiDataFrame,"AbigailButtonTemplate")
	abiTH5:SetWidth(60)
	abiTH5:SetHeight(20)
	abiTH5:SetScript("OnClick",abiSortByPercent)
	abiTH5:SetPoint("TOPLEFT",AuctionFrame,"TOP",317,-54)
	abiTH5:SetText("%age")

	abiOptionsHeader=abiHomeScreenFrame:CreateFontString()
	abiBargainsHeader=abiDataFrame:CreateFontString()
	abiBargainsLastSearch=abiDataFrame:CreateFontString()
	abiShoppingHeader=abiShoppingFrame:CreateFontString()
	abiSellingHeader=abiSellingFrame:CreateFontString()
	abiAdjustingHeader=abiAdjustingFrame:CreateFontString()
	abiDeletingHeader=abiDeletingFrame:CreateFontString()
	abiDeletingHeader2=abiDeletingFrame:CreateFontString()
	abiOptionsFaction=abiHomeScreenFrame:CreateFontString()
	abiBargainsFaction=abiDataFrame:CreateFontString()
	abiShoppingFaction=abiShoppingFrame:CreateFontString()
	abiSellingFaction=abiSellingFrame:CreateFontString()
	abiAdjustingFaction=abiAdjustingFrame:CreateFontString()
	abiDeletingFaction=abiDeletingFrame:CreateFontString()

	abiOptionsHeader:SetPoint("TOPLEFT",abiHomeScreenFrame,"TOPLEFT",270,50)
	abiOptionsHeader:SetFontObject(GameFontNormal)

	if abiTesting==0 then
		abiOptionsHeader:SetText("Abigail 2.30 - Options Screen"..extratext)
	else
		abiOptionsHeader:SetText("Abigail 2.30 - Options Screen"..extratext.." (TESTING)")
	end

	abiBargainsHeader:SetPoint("TOPLEFT",abiDataFrame,"TOPLEFT",250,50)
	abiBargainsHeader:SetFontObject(GameFontNormal)
	abiBargainsHeader:SetText("Abigail 2.30 - Bargain Search Results"..extratext)

	abiBargainsLastSearch:SetPoint("TOPLEFT",abiDataFrame,"TOPLEFT",60,30)
	abiBargainsLastSearch:SetFontObject(GameFontNormal)
	abiBargainsLastSearch:SetText("Abigail 2.30 - Bargain Search Results"..extratext)

	abiShoppingHeader:SetPoint("TOPLEFT",abiShoppingFrame,"TOPLEFT",265,50)
	abiShoppingHeader:SetFontObject(GameFontNormal)
	abiShoppingHeader:SetText("Abigail 2.30 - Shopping Screen")

	abiSellingHeader:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",275,50)
	abiSellingHeader:SetFontObject(GameFontNormal)
	abiSellingHeader:SetText("Abigail 2.30 - Selling Screen"..extratext)

	abiAdjustingHeader:SetPoint("TOPLEFT",abiAdjustingFrame,"TOPLEFT",285,50)
	abiAdjustingHeader:SetFontObject(GameFontNormal)
	abiAdjustingHeader:SetText("Abigail 2.30 - Adjust Price History Screen")

	abiDeletingHeader:SetPoint("TOPLEFT",abiDeletingFrame,"TOPLEFT",285,50)
	abiDeletingHeader:SetFontObject(GameFontNormal)
	abiDeletingHeader:SetText("Abigail 2.30 - Delete Unwanted AH Scan Records")

	abiDeletingHeader2:SetPoint("TOPLEFT",abiDeletingFrame,"TOPLEFT",180,30)
	abiDeletingHeader2:SetFontObject(GameFontNormal)
	abiDeletingHeader2:SetText("|cff00ff00It is recommended you backup the WTF/Account/../Saved Variables/Abigail file.")

	abiOptionsFaction:SetPoint("TOPLEFT",abiHomeScreenFrame,"TOPLEFT",60,50)
	abiOptionsFaction:SetFontObject(GameFontNormal)
	abiOptionsFaction:SetText("|cffffffff"..abiMyFaction)

	abiBargainsFaction:SetPoint("TOPLEFT",abiDataFrame,"TOPLEFT",60,50)
	abiBargainsFaction:SetFontObject(GameFontNormal)
	abiBargainsFaction:SetText("|cffffffff"..abiMyFaction)

	abiShoppingFaction:SetPoint("TOPLEFT",abiShoppingFrame,"TOPLEFT",60,50)
	abiShoppingFaction:SetFontObject(GameFontNormal)
	abiShoppingFaction:SetText("|cffffffff"..abiMyFaction)

	abiSellingFaction:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",60,50)
	abiSellingFaction:SetFontObject(GameFontNormal)
	abiSellingFaction:SetText("|cffffffff"..abiMyFaction)

	abiAdjustingFaction:SetPoint("TOPLEFT",abiAdjustingFrame,"TOPLEFT",60,50)
	abiAdjustingFaction:SetFontObject(GameFontNormal)
	abiAdjustingFaction:SetText("|cffffffff"..abiMyFaction)

	abiDeletingFaction:SetPoint("TOPLEFT",abiDeletingFrame,"TOPLEFT",60,50)
	abiDeletingFaction:SetFontObject(GameFontNormal)
	abiDeletingFaction:SetText("|cffffffff"..abiMyFaction)

end



function MinSpendSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00This is the Minimum Gold you want to spend per auction.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("0");
end



function MaxSpendSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00This is the Maximum Gold you want to spend per auction.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("0");
end



function ProfitMarginSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00This is the Minimum Percentage Profit Margin you are looking for.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("30");
end



function CashProfitSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00This is the Minimum Gold Profit you are looking for.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("0");
end



function DeviationSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00This is the Maximum Price Deviation allowed.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("0");
end



function MaxSameSlider_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "|cffffff00This is the Maximum Number of similar items to include in the Bargains list.";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("0");
end




function AbigailMoneyFrame_Update(frameName, money, quantity, colour)

	local minus=0
	local abiFullMoney=1

	if frameName=="abiMoneyEarnedFrame" or frameName=="abiMoneySpentFrame" or frameName=="abiMoneyProfitFrame" then
		abiFullMoney=0
	end

	money=tonumber(money) --just converting for those times it comes through as a string (ie showing best 5)

	if money<0 then
		minus=1
		money=abs(money)
	end

	if ( type(frameName) == "table" ) then

		local frame = frameName
		frameName = frame:GetName()

	end
	-- Breakdown the money into denominations
	local gold=floor(money/10000)
	local silver=floor((money-(gold*10000))/100)
	local copper=mod(money,100)
	local goldButton = _G[frameName.."GoldButton"]
	local silverButton = _G[frameName.."SilverButton"]
	if quantity~=0 then

		if quantity=="Earned" or quantity=="Spent" or quantity=="Profit" or quantity=="Loss" then
			gold=tostring(quantity).." : "..tostring(gold)
		else
			gold=tostring(quantity).."  x  "..tostring(gold)
		end

	end

	if minus==1 then
		gold="-"..gold
	end

	-- Set values for each denomination
	goldButton:SetText(colour..gold)
	goldButton:SetWidth(goldButton:GetTextWidth() + 13)
	goldButton:Show()
	silverButton:SetText(colour..silver)
	silverButton:SetWidth(30)
	silverButton:Show()
	if abiFullMoney==1 then
		local copperButton = _G[frameName.."CopperButton"]
		copperButton:SetText(colour..copper)
		copperButton:SetWidth(30)
		copperButton:Show()
	end
end



function CheckIfOneOfMyAuctions(passedname,passedcount,passedprice)
	-- returns zero if not one of my auctions

	if (#abiMyTempAuctions==0) or (#abiMyTempAuctions==nil) then
		return 0
	end

	for i=1,#abiMyTempAuctions do

		if abiMyTempAuctions[i]==passedname.."%"..passedcount.."%"..passedprice then
			table.remove(abiMyTempAuctions,i)
			return 1
		end

	end

	return 0

end



function CheckIfOneOfMyBids(passedname,passedcount,passedprice)
	-- returns zero if I have not bid on this item

	if (#abiMyTempBids==0) or (#abiMyTempBids==nil) then
		return 0
	end

	for i=1,#abiMyTempBids do

		if abiMyTempBids[i]==passedname.."%"..passedcount.."%"..passedprice then
			table.remove(abiMyTempBids,i)
			return 1
		end

	end

	return 0

end



function abiCheckDeviation(passed) -- the image price
	local abiTemporaryNumber=DeviationSlider:GetValue()

	if abiTemporaryNumber==0 then
		return 1
	end

	if passed>(abiHistoryCost[1]*(100+abiTemporaryNumber)/100) then
		return 0
	end

	if passed<abiHistoryCost[#abiHistoryCost]*(1-(abiTemporaryNumber/100)) then
		return 0
	end

	return 1
end



function abiCheckTheType(passed)
	-- checks for each item type	

	for abiloop=1,11 do

		if _G["abiTypeCheck"..abiloop]:GetChecked()==1 and passed==abiTypeTable[abiloop] then
			return 1
		end

	end
	return 0
end



function abiCheckThePrice(ItemPrice,AveragePrice,ActualBuyoutPrice)
	-- if abiBidBuyoutButton is checked - the AveragePrice is actually the Buyout Price of the item
	local tempcount=ActualBuyoutPrice/ItemPrice
	if ItemPrice>=AveragePrice then
		return 0
	end

	if ActualBuyoutPrice<MinSpendSlider:GetValue()*10000 or
	ActualBuyoutPrice>(MaxSpendSlider:GetValue()*10000) and MaxSpendSlider:GetValue()~=0 then
		return 0
	end

	if ((AveragePrice-ItemPrice)/ItemPrice)<(ProfitMarginSlider:GetValue()/100) or
	((AveragePrice*tempcount)-ActualBuyoutPrice)<CashProfitSlider:GetValue()*10000 then
		return 0
	end

	return 1
end



function HowmanySecondsDelay(passed)
	local delay
	delay=time()+passed
	while time()<delay do
	end
end



function abiCalculateStackSize(passed)
	local abitemp

	if string.sub(passed,-1)~=")" then
		return 1
	end

	abitemp=tonumber(string.sub(passed,string.find(passed,"%(")+1,#passed-1))

	if abitemp==nil then
		abitemp=1
	end

	return abitemp

end



function abiPLButtonClicked()
	abiPLV[abiRealm][1]=0
	abiPLV[abiRealm][2]=0
	abiShowProfitLossFrames()
end



function abiCreateExtraBits()

	f=CreateFrame("Button","abiCreateSnapShotButton",abiHomeScreenFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",584,-409)
	f:SetScript("OnClick",abiCreateSnapShotButton_OnClick)
	f:SetWidth(122)
	f:SetHeight(24)
	f:SetText("Take Snapshot")
	abiCreateSnapShotButton.tooltipText="|cffffff00Take a snapshot of all items |ncurrently being auctioned."


	f=CreateFrame("Button","abiBargainSearchButton",abiHomeScreenFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",704,-409)
	f:SetScript("OnClick",abiBargainSearchButton_OnClick)
	f:SetWidth(122)
	f:SetHeight(24)
	f:SetText("Search Bargains")
	f:Disable()
	abiBargainSearchButton.tooltipText="|cffffff00Search the snapshot for bargains/bids."

	f=CreateFrame("Button","abiSelectWhichBidToUseButton",abiHomeScreenFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",493,-342)
	f:SetScript("OnClick",abiSelectWhichBidToUseButton_OnClick)
	f:SetWidth(150)
	f:SetHeight(24)
	f:SetText("Buyouts")
	f:Enable()
	abiSelectWhichBidToUseButton.tooltipText="|cffffff00Search for items with these |nbid durations, or choose Buyouts |nto get all items with a buyout price. |nCan also check if your auctions |nhave been undercut."

	f=CreateFrame("Button","abiSelectScanTypeButton",abiHomeScreenFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",493,-370)
	f:SetScript("OnClick",abiSelectScanTypeButton_OnClick)
	f:SetWidth(150)
	f:SetHeight(24)
	f:SetText("Quick Get All Scan")
	f:Enable()
	abiSelectScanTypeButton.tooltipText="|cffffff00Do a full GetAll scan or |na slow page-by-page scan. |n|n(Use page-by-page if you are having |nscanning problems)"

	f=CreateFrame("Button","abiCurrentMainButton",abiHomeScreenFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",645,-370)
	f:SetScript("OnClick",abiSelectCurrentMainButton_OnClick)
	f:SetWidth(130)
	f:SetHeight(24)
	f:SetText("Full Price History")
	f:Enable()
	abiCurrentMainButton.tooltipText="|cffffff00Compare all items against the |nfull history of prices, or just |nagainst the current prices |nin the Auction House."

	f=CreateFrame("Button","abiShowingFiveButton",abiDataFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",584,-409)
	f:SetScript("OnClick",abiShowingFiveButton_OnClick)
	f:SetWidth(122)
	f:SetHeight(24)
	f:SetText("Show Best 5 : Off")
	f:Enable()
	abiShowingFiveButton.tooltipText="|cffffff00Show the 5 best-value auctions for an item."

	f=CreateFrame("Button","abiStackUnitButton",abiDataFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",704,-409)
	f:SetScript("OnClick",abiStackUnitButton_OnClick)
	f:SetWidth(122)
	f:SetHeight(24)
	f:SetText("Prices Per Stack")
	abiStackUnitButton.tooltipText="|cffffff00Show prices as the full Auction Price |nor as per-item price."

	f=CreateFrame("Button","abiNoBargainsFoundButton",AuctionFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",584,-409)
	f:SetWidth(242)
	f:SetHeight(24)
	f:SetText("No Bargains Have Been Found")
	f:Disable()
	f:Hide()

	f=CreateFrame("Button","abiNoSnapshotTakenButton",AuctionFrame,"UIPanelButtonTemplate")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",584,-409)
	f:SetWidth(242)
	f:SetHeight(24)
	f:SetText("No Snapshot Has Been Taken")
	f:Disable()
	f:Hide()

	f=abiDataFrame:CreateFontString("abiShowingWhichBargainsString")
	f:SetPoint("TOPLEFT",AuctionFrame,"TOPLEFT",530,-35)
	f:SetFontObject(GameFontNormal)
	f:SetWidth(289)
	f:SetHeight(20)
	f:SetJustifyH("RIGHT")
	f:SetText(" ")
	f:Hide()

end


