-- Sell-All page for Abigail 2.30
-- 17/12/13


local abiSellHelpText={}
local abiSellAllTable={}
local abiSellBuyoutPrice={}
local abiSellBidPrice={}
local abiSellCheapestPrice={}
local abiSellDefaultBuy={}
local abiSellPriceType={}
local abiSellFiveAuctions={}
local abiProtectList={}
local abiMyFaction,_=UnitFactionGroup("Player")
local abiRealm=GetRealmName()..abiMyFaction
local abiSellTableOffset=0
local abiProtectListOffset=0
local abiAHType=1
local abiSearchDone=0
local abiReadWhichItem
local abiDoingARead=0
local abiRoundingPrice=0
local abiDuration=3
local abiDurTable={"12 Hrs","24 Hrs","48 Hrs"}
local abiAuctionDuration={"Short","Medium","Long","V.Long"}
local abiSellShowTooltip=0
local abiPassedValue=0
local abiPopUpShown=0
local abiNilLink="|cff9d9d9d|Hitem:0000:0:0:0:0:0:0:0:80:0:0|h[Nil Item]|h|r"
local abiProtected=0
local abiVendorToDeposit=0.1498786

abiSellHelpText[1]="Auction all items in all bags."

abiSellHelpText[7]="Undercut the Auction Price."

abiSellHelpText[9]="L-Click = Create an Auction,  R-Click = Toggle Unit/Stack."
abiSellHelpText[10]="L-Click = Copy Name,  R-Click = Toggle Tooltip"

abiSellHelpText[12]="Set those items to protect from being sold."


function abiSellingFrame_OnLoad()
	abiSellingFrame:Hide()
	abiSellingResetButton:Disable()
	abiSellingProtectButton:Disable()
	abiSellingFrame:RegisterEvent("MODIFIER_STATE_CHANGED")
	abiSimpleProfitButton:Disable()
	abiRecentPricesButton:Disable()
	abiSimpleProfitButton.tooltipText="|cffffff00Set selling prices to just double|nyour recent purchase price."
	abiSellingResetButton.tooltipText="|cffffff00Reset all prices and sliders|nto their default values."
	abiSellingAHTypeButton.tooltipText="|cffffff00Toggles selling the items|nindividually or as a stack."
	abiSellingSearchButton.tooltipText="|cffffff00Reads all items in your bags|nand suggests selling prices."
	abiSellingTimeButton.tooltipText="|cffffff00Set the duration of|nyour auction."
	abiSellingProtectButton.tooltipText="|cffffff00Set those items to protect|nfrom being sold."
	abiRecentPricesButton.tooltipText="|cffffff00Set selling prices to same|nas the most recent low price."
end



function abiSellingProtectFrame_OnLoad()
	abiIH1.tooltipText="|cffffff00Tick an item to protect it|nfrom appearing in your selling list."
	abiIH2.tooltipText="|cffffff00The name of the item that can|nbe protected.|n|n(The number in brackets is|nthe Item Level.)"
end



function abiSellingAHTypeButtonClicked()

	if abiPopUpShown==1 then
		return
	end

	if abiAHType==1 then
		abiSellingAHTypeButton:SetText("Per Stack")
		abiAHType=2
	else
		abiSellingAHTypeButton:SetText("Per Unit")
		abiAHType=1
	end

	if #abiSellAllTable==0 then
		return
	end

	abiDisplayTheSellingItems()
end



function abiSellHelp(passed)
	abiSellFrameHelp:SetText("|cffffffff"..abiSellHelpText[passed])
end



function abiSellingResetButtonClicked()

	if abiPopUpShown==1 then
		return
	end

	abiSellAllTable=table.wipe(abiSellAllTable)
	abiSellBuyoutPrice=table.wipe(abiSellBuyoutPrice)
	abiSellBidPrice=table.wipe(abiSellBidPrice)
	abiSellCheapestPrice=table.wipe(abiSellCheapestPrice)
	abiSellDefaultBuy=table.wipe(abiSellDefaultBuy)
	abiSellPriceType=table.wipe(abiSellPriceType)
	abiSellTableOffset=0
	abiAHType=1
	abiSearchDone=0
	abiSellingAHTypeButton:SetText("Per Unit")
	abiSellingSlider2Text:SetText("0%")
	abiSellingSlider1Text:SetText("10%")
	abiSellingSlider3Text:SetText("10%")
	abiSellingSlider2:SetValue(0)
	abiSellingSlider1:SetValue(10)
	abiSellingSlider3:SetValue(10)
	abiSellingSearchButtonClicked()
	abiDuration=3
	abiSellingTimeButton:SetText("48 Hrs")
end



function abiSellingSearchButtonClicked()

	if abiPopUpShown==1 then
		return
	end

	abiSellAllTable=table.wipe(abiSellAllTable)
	abiSellBuyoutPrice=table.wipe(abiSellBuyoutPrice)
	abiSellBidPrice=table.wipe(abiSellBidPrice)
	abiSellCheapestPrice=table.wipe(abiSellCheapestPrice)
	abiSellPriceType=table.wipe(abiSellPriceType)
	abiProtectList=table.wipe(abiProtectList)
	local abiBagName
	local abiSlots
	local abiTexture,abiCount,abiLink,abiQuality,abiLootable
	local abiCurrDurability,abiMaxDurability

	if abiProtectTable==nil then
		abiProtectTable={}
	end

	-- close any open bags
	for abiloop=1,5 do
		_G["ContainerFrame"..abiloop]:Hide()
	end

	-- now open them in order
	for abiloop=0,4 do
		ToggleBag(abiloop)
	end

	-- and read the auctionable items from the bags
	for abiBag=0,4 do
		abiSlots=GetContainerNumSlots(abiBag)

		if abiSlots~=0 then

			for abiloop=1,abiSlots do
				abiTexture,abiCount,_,abiQuality,_,abiLootable,abiLink=GetContainerItemInfo(abiBag,abiloop)
				abiCurrDurability,abiMaxDurability=GetContainerItemDurability(abiBag,abiloop)
				if abiCount~=nil then
					abiName=abiDecodeItemLink(abiLink)
					f = CreateFrame('GameTooltip', 'SellingTooltip', UIParent, 'GameTooltipTemplate')
					f:SetOwner(UIParent, 'ANCHOR_NONE')
					f:SetBagItem(abiBag,abiloop)

					if abiLootable==nil and abiCheckSoulbound(f)==0 and abiIsItProtected(abiName,abiQuality)==0 and abiCurrDurability==abiMaxDurability then -- also checks for 'Battle.net Account Bound'
						abiSellAllTable[#abiSellAllTable+1]=abiName.."%"..abiCount.."%"..abiBag.."%"..abiloop.."%"..abiLink.."%"..abiQuality
						abiSellCheapestPrice[#abiSellCheapestPrice+1]=0
					end
	

					_,_,_,_,_,_,_,_,_,_,abiVendor=GetItemInfo(abiLink)

					if abiVendor==nil then
						abiVendor=0
					end
					if abiVendor==0 then
						abiVendor=1
					end
					if abiLink==nil then
						abiLink=abiNilLink
					end

					if abiPriceIndex[abiRealm][abiName]==nil then
						abiPriceIndex[abiRealm][abiName]=abiLink.."%0%0%0%0%0:0%0:0%0:0%0:0%"..time().."%0:0%0:0%x%"..abiVendor.."*1"
					end

					if abiCurrentAuctions[abiName]==nil then
						abiCurrentAuctions[abiName]=abiLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%"..abiVendor.."*1"
					end

					f:Hide()
				end
			end
		end
	end

	abiGetSellingPrices(0)
	abiSellingScrollFrameUpdate()
	abiDisplayTheSellingItems()

	abiSellingProtectButton:Enable()
	abiSellingResetButton:Enable()
	abiSimpleProfitButton:Enable()
	abiRecentPricesButton:Enable()

	abiSearchDone=1
	abiSellFrameHelp:SetText("|cffffffff"..#abiSellAllTable.." auctionable items found")

	abiSellingScrollFrame:SetVerticalScroll(0)
	abiProtectScrollFrame:SetVerticalScroll(0)
	abiSellTableOffset=0
	abiProtectListOffset=0

end



function abiCheckSoulbound(f)
	local lines=f:NumLines()

	for abiloop=1,lines do
		t=_G["SellingTooltipTextLeft"..abiloop]:GetText()

		if t=="Soulbound" or t=="Battle.net Account Bound" then
			return 1
		end

	end

	return 0
end



function abiDisplayTheSellingItems()
	local abiStart
	local abiFinish
	local abiOneToTwelve

	for abiloop=1,12 do
		_G["abiSellingName"..abiloop]:SetText("empty")
		_G["abiSellingName"..abiloop]:Show()
		_G["abiSellingBuy"..abiloop]:Hide()
		_G["abiSellingBid"..abiloop]:Hide()
		_G["abiPriceType"..abiloop]:Hide()
		_G["abiSellingButton"..abiloop]:Hide()
		_G["abiUC"..abiloop]:Hide()
	end


	abiStart=1+abiSellTableOffset
	abiFinish=12+abiSellTableOffset

	if abiFinish>#abiSellAllTable then
		abiFinish=#abiSellAllTable
		abiStart=abiFinish-11
	end

	if abiStart<1 then
		abiStart=1
	end

	if abiStart<=abiFinish then

		for abiloop=abiStart,abiFinish do

			abiOneToTwelve=abiloop-abiStart+1
			abiName,abiCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[abiloop])

			_G["abiSellingName"..abiOneToTwelve]:SetTextColor(1,0.9,0,0.9)
			_G["abiSellingName"..abiOneToTwelve]:SetFontObject("GameFontNormal")

			if abiName=="This Item Auctioned" then
				_G["abiSellingName"..abiOneToTwelve]:SetText(abiName)
				_G["abiSellingButton"..abiOneToTwelve]:Disable()
				_G["abiSellingButton"..abiOneToTwelve]:Show()
				_G["abiPriceType"..abiOneToTwelve]:SetText("-")
				_G["abiPriceType"..abiOneToTwelve]:Show()
			else
				_G["abiSellingName"..abiOneToTwelve]:SetText(abiCount.." x "..abiName)
				_G["abiSellingButton"..abiOneToTwelve]:Enable()
				_G["abiSellingButton"..abiOneToTwelve]:Show()
				_G["abiPriceType"..abiOneToTwelve]:SetText(abiSellPriceType[abiloop])
				_G["abiPriceType"..abiOneToTwelve]:Show()

			end
			
			if abiAHType==1 then
				abiCount=1
			end

			if abiName=="This Item Auctioned" then
				abiSellBuyoutPrice[abiloop]=0
				abiSellBidPrice[abiloop]=0
			else
				abiSellBuyoutPrice[abiloop]=abiGetBuyoutPrice(abiloop,abiCount)
				abiSellBidPrice[abiloop]=abiGetBidPrice(abiSellBuyoutPrice[abiloop])
			end
			
			AbigailMoneyFrame_Update(_G["abiSellingBuy"..abiOneToTwelve],abiSellBuyoutPrice[abiloop],0,"|cffffffff")		
			_G["abiSellingBuy"..abiOneToTwelve]:Show()
			AbigailMoneyFrame_Update(_G["abiSellingBid"..abiOneToTwelve],abiSellBidPrice[abiloop],0,"|cffffffff")
			_G["abiSellingBid"..abiOneToTwelve]:Show()

			AbigailMoneyFrame_Update(_G["abiSellingCheap"..abiOneToTwelve],abiSellCheapestPrice[abiloop]*abiCount,0,"|cffffffff")

			if abiSellCheapestPrice[abiloop]>0 then
				_G["abiSellingCheap"..abiOneToTwelve]:Show()
				_G["abiUC"..abiOneToTwelve]:Enable()
			else
				_G["abiSellingCheap"..abiOneToTwelve]:Hide()
				_G["abiUC"..abiOneToTwelve]:Disable()
			end

			_G["abiUC"..abiOneToTwelve]:Show()
		end
	end
end



function abiGetBuyoutPrice(itemnumber,count)
	local bought
	local ret
	local gold,silver1,silver2

	bought=1+(abiSellingSlider2:GetValue()/100)
	ret=math.floor(abiSellDefaultBuy[itemnumber]*bought*count)
	
	if abiRoundingPrice==1 then
		gold=floor(ret/10000)
		silver1=(ret-(gold*10000))/100

		if silver1<10 and gold<1 then
			silver2=math.ceil(silver1)
		else
			silver1=(ret-(gold*10000))/1000
			silver2=math.ceil(silver1)*10
		end

		if silver2==100 then
			silver2=0
			gold=gold+1
		end

		ret=(gold*10000)+(silver2*100)

		if ret<200 then
			ret=200
		end
	end

	if ret<2 then
		ret=2
	end
	
	return ret
end



function abiGetBidPrice(buyout)
	local bid
	local ret

	bid=1-(abiSellingSlider1:GetValue()/100)

	ret=math.floor(buyout*bid)
	return ret
end



function abiSellMessageFrame_OnEnter(passed,shifted)

	if abiPopUpShown==1 or abiProtected==1 then
		return
	end

	local abiSellLink,abiSellName,abiSellCount
	local t=passed+abiSellTableOffset

	if t<=#abiSellAllTable then
		abiPresets[abiWhichPreset][24]=1
		abiSellName,abiSellCount,_,_,abiSellLink,_=abiDecodeSellAllTable(abiSellAllTable[t])
		GameTooltip:Hide()

		if shifted==1 or IsLeftShiftKeyDown()==1 or IsRightShiftKeyDown()==1 then
			abiPresets[abiWhichPreset][24]=abiSellCount
		end

		if abiSellName~="This Item Auctioned" and abiSellShowTooltip==1 then

			if strmatch(abiSellLink,"battlepet") then
				GameTooltip:SetOwner(abiSellingFrame,"ANCHOR_CURSOR")
				GameTooltip:ClearLines()
				GameTooltip:AddLine("Battle Pet")
				GameTooltip:AddLine("|cffffffff"..abiSellName)
				abiAddTooltipData(GameTooltip,abiSellName)
				GameTooltip:Show()
			else
				GameTooltip:SetOwner(abiSellingFrame,"ANCHOR_CURSOR")
				GameTooltip:SetHyperlink(abiSellLink)
				GameTooltip:Show()
			end

		end
		abiHighlightTheText(passed)
		abiSellHelp(10)
	end
end



function abiHighlightTheText(passed)
	local t

	_G["abiSellingName"..passed]:SetTextColor(1,1,1,1)
	_G["abiSellingName"..passed]:SetFontObject("GameFontNormalLarge")

	t=abiSellBuyoutPrice[passed+abiSellTableOffset]

	abiName,abiCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[passed+abiSellTableOffset])


	if t~=nil then
		AbigailMoneyFrame_Update(_G["abiSellingBuy"..passed],t,0,"|cffff4040")
	end

	t=abiSellBidPrice[passed+abiSellTableOffset]

	if t~=nil then
		AbigailMoneyFrame_Update(_G["abiSellingBid"..passed],t,0,"|cffff4040")
	end

	_G["abiSellingBid"..passed.."GoldButtonText"]:SetFontObject("NumberFontNormalLarge")
	_G["abiSellingBid"..passed.."SilverButtonText"]:SetFontObject("NumberFontNormalLarge")
	_G["abiSellingBid"..passed.."CopperButtonText"]:SetFontObject("NumberFontNormalLarge")

	_G["abiSellingBuy"..passed.."GoldButtonText"]:SetFontObject("NumberFontNormalLarge")
	_G["abiSellingBuy"..passed.."SilverButtonText"]:SetFontObject("NumberFontNormalLarge")
	_G["abiSellingBuy"..passed.."CopperButtonText"]:SetFontObject("NumberFontNormalLarge")

end



function abiSellMessageFrame_OnLeave(passed)

	if abiPopUpShown==1 or abiProtected==1 then
		return
	end

	local t
	_G["abiSellingName"..passed]:SetTextColor(1,0.9,0,0.9)
	_G["abiSellingName"..passed]:SetFontObject("GameFontNormal")

	if passed+abiSellTableOffset<=#abiSellAllTable then
		t=abiSellBuyoutPrice[passed+abiSellTableOffset]
		abiName,abiCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[passed+abiSellTableOffset])

		if t~=nil then
			AbigailMoneyFrame_Update(_G["abiSellingBuy"..passed],t,0,"|cffffffff")
		end

		t=abiSellBidPrice[passed+abiSellTableOffset]

		if t~=nil then
			AbigailMoneyFrame_Update(_G["abiSellingBid"..passed],t,0,"|cffffffff")
		end

		_G["abiSellingBid"..passed.."GoldButtonText"]:SetFontObject("NumberFontNormal")
		_G["abiSellingBid"..passed.."SilverButtonText"]:SetFontObject("NumberFontNormal")
		_G["abiSellingBid"..passed.."CopperButtonText"]:SetFontObject("NumberFontNormal")

		_G["abiSellingBuy"..passed.."GoldButtonText"]:SetFontObject("NumberFontNormal")
		_G["abiSellingBuy"..passed.."SilverButtonText"]:SetFontObject("NumberFontNormal")
		_G["abiSellingBuy"..passed.."CopperButtonText"]:SetFontObject("NumberFontNormal")

		GameTooltip:Hide()
		abiSellHelp(1)
	end
end



function abiSellMouseDown(passed,button)

	if abiPopUpShown==1 or abiProtected==1 then
		return
	end

	local abiSellName
	local t=passed+abiSellTableOffset

	if t<=#abiSellAllTable then
		abiSellName,_,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[t])

		if abiSellName~="This Item Auctioned" and button=="LeftButton" then

			if IsShiftKeyDown()==1 then
				abiSellName=abiShortenName(abiSellName)
			end

			--Put the item name into the BrowseName field of main AH window
			BrowseName:SetText(abiSellName)

			--Now put it in Search field of Adjusting Screen
			abiAdjBrowseName:SetText(abiSellName)

			if (IsAddOnLoaded("Auctionator")) then
				Atr_Search_Box:SetText(abiSellName)
			end

		end

		if button=="RightButton" then
			abiSellShowTooltip=1-abiSellShowTooltip
			abiSellMessageFrame_OnEnter(passed)
		end

	end
end



function abiSellButton_OnEnter(passed)

	if abiPopUpShown~=1 then
		abiSellHelp(9)
		abiHighlightTheText(passed)
		abiSellButtonTooltip(passed)
	end

end



function abiSellButton_OnLeave(passed)

	if abiPopUpShown~=1 then
		abiSellHelp(1)
		abiSellMessageFrame_OnLeave(passed)
		GameTooltip:Hide()
	end
end



function abiSellButtonTooltip(passed)
	local abiRsold,abiRbought,abiTemp,abiRecentHigh,abiRecentLow
	local abiRH,abiRL,abiHT,abiLT
	if abiPopUpShown==1 or abiDoingARead>0 then
		return
	end

	local abiSelling=passed+abiSellTableOffset
	local abiSellName,abiSellCount,abiSellBag,abiSellSlot,abiSellLink
	local abiDeposit, abiSingleDeposit
	local frame
	local abiHowmany
	local t1,t2,t3,t4
	frame=_G["abiSellingButton"..passed]
	GameTooltip:SetOwner(frame,"ANCHOR_RIGHT")

	abiSellName,abiSellCount,abiSellBag,abiSellSlot,abiSellLink,_=abiDecodeSellAllTable(abiSellAllTable[abiSelling])

	_,_,_,_,_,_,_,_,_,_,abiDeposit=GetItemInfo(abiSellName)

	_,_,_,_,_,abiRsold,abiRbought,_,_,_,abiRecentHigh,abiRecentLow,_=abiDecodeIndex(abiPriceIndex[abiRealm][abiSellName])
	abiRsold,_=strsplit(":",abiRsold)
	abiRbought,_=strsplit(":",abiRbought)
	abiRH,abiHT=strsplit(":",abiRecentHigh)
	abiRL,abiLT=strsplit(":",abiRecentLow)
	abiRH=tonumber(abiRH)
	abiRL=tonumber(abiRL)

	abiRsold=tonumber(abiRsold)
	abiRbought=tonumber(abiRbought)
	abiTemp=1

	if abiAHType==2 then
		abiRsold=abiRsold*abiSellCount
		abiRbought=abiRbought*abiSellCount
		abiRH=abiRH*abiSellCount
		abiRL=abiRL*abiSellCount
		abiTemp=abiSellCount
	end

	if abiDeposit==nil then
		abiDeposit=1
	end

	abiDeposit=math.floor((abiDeposit*abiVendorToDeposit)+0.5)

	if abiDuration==2 then
		abiDeposit=abiDeposit*2
	end

	if abiDuration==3 then
		abiDeposit=abiDeposit*4
	end

	abiSingleDeposit=abiDeposit

	abiDeposit=abiDeposit*abiSellCount

	if abiDeposit<100 then
		abiDeposit=100
	end

	if abiSingleDeposit<100 then
		abiSingleDeposit=100
	end

	if abiAHType==1 then
		abiDeposit=abiSingleDeposit*abiSellCount
	end


	GameTooltip:AddLine("Additional Data")

	if abiSellCount~=1 then
		GameTooltip:AddDoubleLine("Single Deposit : ",abiCreatePriceStringIcons(abiSingleDeposit,""),1,1,1,1,1,1)
	end


	GameTooltip:AddDoubleLine("Total Deposit : ",abiCreatePriceStringIcons(abiDeposit,""),1,1,1,1,1,1)

	if abiRbought==0 then
		GameTooltip:AddDoubleLine("Recent Buy (stack = "..abiTemp..") : ","--------------",1,1,1,1,1,1)
	else
		GameTooltip:AddDoubleLine("Recent Buy (stack = "..abiTemp..") : ",abiCreatePriceStringIcons(abiRbought,""),1,1,1,1,1,1)
	end

	if abiRsold==0 then
		GameTooltip:AddDoubleLine("Recent Sold (stack = "..abiTemp..") : ","--------------",1,1,1,1,1,1)
	else
		GameTooltip:AddDoubleLine("Recent Sold (stack = "..abiTemp..") : ",abiCreatePriceStringIcons(abiRsold,""),1,1,1,1,1,1)
	end

	GameTooltip:AddDoubleLine("Latest High : ",abiCreatePriceStringIcons(abiRH,""),1,1,1,1,1,1)
	GameTooltip:AddDoubleLine("Latest Low : ",abiCreatePriceStringIcons(abiRL,""),1,1,1,1,1,1)

	GameTooltip:AddDoubleLine(" "," ")

	if #abiSellFiveAuctions==0 then
		GameTooltip:AddLine("A 'Get Low' must be done",1,0,0)
		GameTooltip:AddLine("before auction details are shown",1,0,0)
		GameTooltip:Show()
		return
	end

	abiHowmany=#abiSellFiveAuctions[abiSelling]

	if abiHowmany>5 then
		abiHowmany=5
	end

	if abiHowmany>0 then

		if abiAHType==1 then
			GameTooltip:AddLine("Current Auctions Per Unit")
		else
			GameTooltip:AddLine("Current Auctions Per Stack")
		end

		for abiloop=1,abiHowmany do
			t1,t2,t3,t4=strsplit("%",abiSellFiveAuctions[abiSelling][abiloop])
			t1=tonumber(t1)
			t2=tonumber(t2)
			t3=tonumber(t3)
			t4=tonumber(t4)

			if abiAHType==2 then
				t1=t4
			end

			GameTooltip:AddDoubleLine("Stack of ("..t2..") ".."|Cff88ff88"..abiAuctionDuration[t3],abiCreatePriceStringIcons(t1,""),1,1,1,1,1,1)

		end
	else
		GameTooltip:AddLine("No Other Auctions")
	end

	GameTooltip:Show()
end



function abiGetSellingPrices(passed)
	if abiPopUpShown==1 then
		return
	end

	local aName,aCount,aBag,aSlot
	local abiMAname,abiMAcount,abiMAbuyout
	local Bhigh,Blow,Shigh,Slow,Rsold,Rbought,Ratio,Seen,PriceHistory,RecentHigh,RecentLow
	local Vendor
	local aAverage,aMean
	local aTemp
	local percent=1-(abiSellingSlider1:GetValue()/100)
	local bought=1+(abiSellingSlider2:GetValue()/100)
	local RH,RL
	abiRealm=GetRealmName()..abiMyFaction -- just make sure

	if abiPriceIndex[abiRealm]==nil then
		abiPriceIndex[abiRealm]={} -- just make sure
	end

	abiGetMyAuctions()
	--name%count%buyout

	if #abiSellAllTable>0 then

		for abiloop=1,#abiSellAllTable do

			abiSellBuyoutPrice[abiloop]=0
			abiSellBidPrice[abiloop]=0
			aName,aCount,aBag,aSlot,_,_=abiDecodeSellAllTable(abiSellAllTable[abiloop])
			_,_,_,_,_,_,_,_,_,_,Vendor=GetItemInfo(aName)

			if aName~="This Item Auctioned" then

				if abiAHType==1 then
					aCount=1
				end
	
				if Vendor==nil then
					Vendor=10000 -- default 1 gold if never seen
				end

				if Vendor==0 then
					Vendor=10000 -- default 1 gold
				end

				if abiPriceIndex[abiRealm][aName]==nil then -- not seen before, needs adding to index file
					abiPriceIndex[abiRealm][aName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%"..time().."%0:0%0:0%x%"..abiMakeFullPrice(Vendor).."*1"
				end

				if abiCurrentAuctions[aName]==nil then -- not seen before, needs adding to index file
					abiCurrentAuctions[aName]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%"..abiMakeFullPrice(Vendor).."*1"
				end

				if abiCurrent==0 then
					_,Bhigh,Blow,Shigh,Slow,Rsold,Rbought,Ratio,Seen,abiTimeStamp,RecentHigh,RecentLow,PriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][aName])
				else
					_,Bhigh,Blow,Shigh,Slow,Rsold,Rbought,Ratio,Seen,abiTimeStamp,RecentHigh,RecentLow,PriceHistory=abiDecodeIndex(abiCurrentAuctions[aName])
				end

				abiDecodePriceHistory(PriceHistory)
				aAverage=abiFindAveragePrice()
				aMean=abiFindMeanPrice()
				abiSellDefaultBuy[abiloop]=9999999999

				if passed==1 then
					RL,_=strsplit(":",RecentLow)
					RL=tonumber(RL)
					if RL>0 then
						abiSellDefaultBuy[abiloop]=RL
						abiSellPriceType[abiloop]="7"
					end
				end

				if #abiMyAuctions>0 then

					for abiloop2=1,#abiMyAuctions do
						abiMAname,abiMAcount,abiMAbuyout=strsplit("%",abiMyAuctions[abiloop2])
						abiMAcount=tonumber(abiMAcount)
						abiMAbuyout=math.floor(tonumber(abiMAbuyout)/abiMAcount)

						if abiMAname==aName and abiMAbuyout<abiSellDefaultBuy[abiloop] and abiMAbuyout>0 then
							abiSellDefaultBuy[abiloop]=abiMAbuyout
							abiSellPriceType[abiloop]="M"
						end

					end

				end

				if Shigh>0 and abiSellDefaultBuy[abiloop]==9999999999 then
					abiSellPriceType[abiloop]="S"
					abiSellDefaultBuy[abiloop]=math.floor((Shigh+Slow)/2)
				end

				if Shigh==0 and Bhigh>0 and abiSellDefaultBuy[abiloop]==9999999999 then
					aTemp=(Bhigh+Vendor)*3

					if aTemp>(Bhigh*25) then
						aTemp=Bhigh*25
					end

					abiSellPriceType[abiloop]="B"

					if aTemp<abiHistoryCost[#abiHistoryCost] then
						aTemp=abiHistoryCost[#abiHistoryCost]
						abiSellPriceType[abiloop]="L"
					end

					abiSellDefaultBuy[abiloop]=aTemp
				end

				if Shigh==0 and Bhigh==0 and abiSellDefaultBuy[abiloop]==9999999999 then
					aTemp=math.floor((abiHistoryCost[1]/aAverage)*abiHistoryCost[#abiHistoryCost])
					abiSellPriceType[abiloop]="L"
					abiSellDefaultBuy[abiloop]=aTemp

					if abiSellDefaultBuy[abiloop]>aAverage then
						abiSellDefaultBuy[abiloop]=aAverage
						abiSellPriceType[abiloop]="A"
					end

				end

			else
				abiSellDefaultBuy[abiloop]=0
			end

		end
	end
	abiSellingLowestPrice() -- Get the lowest current prices
end



function abiSellingLowestPrice()

	if abiPopUpShown==1 then
		return
	end

	if #abiSellAllTable>0 then

		for abiloop=1,#abiSellAllTable do
			abiSellCheapestPrice[abiloop]=0
		end

		abiSellFiveAuctions=table.wipe(abiSellFiveAuctions)
		abiReadWhichItem=1
		abiActuallyReadTheItem()
	end
end



function abiActuallyReadTheItem()
	local temp=0
	abiDoingARead=0
	local aName,aCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[abiReadWhichItem])
	abiSellFiveAuctions[abiReadWhichItem]={}

	if aName~="This Item Auctioned" then

		for abiloop=1,#abiAHImage do
			abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiloop])
			temp=abiImagePrice
			abiImagePrice=math.floor(abiImagePrice/abiImageCount)

			if aName==abiImageName then
				abiSellFiveAuctions[abiReadWhichItem][#abiSellFiveAuctions[abiReadWhichItem]+1]=abiMakeFullPrice(abiImagePrice).."%"..abiImageCount.."%"..abiImageTime.."%"..temp
			end

		end
	end

	table.sort(abiSellFiveAuctions[abiReadWhichItem])

	if #abiSellFiveAuctions[abiReadWhichItem]~=nil and #abiSellFiveAuctions[abiReadWhichItem]~=0 then
		temp,_,_,_=strsplit("%",abiSellFiveAuctions[abiReadWhichItem][1])
		temp=tonumber(temp)

		abiSellCheapestPrice[abiReadWhichItem]=temp
	end
	
	abiReadWhichItem=abiReadWhichItem+1

	if abiReadWhichItem<=#abiSellAllTable then
		abiDisplayTheSellingItems()
		abiDoingARead=1
		return
	end

	abiDisplayTheSellingItems()
	abiDoingARead=2
end



function abiSellingMakeFrames()

	for abiloop=1,12 do
		f=abiSellingFrame:CreateFontString("abiSellingName"..abiloop)
		f:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",48,0-(abiloop*20))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(240)
		f:SetHeight(20)
		f:SetJustifyH("LEFT")
		f:Hide()

		framename="abiSellingBuy"..abiloop
		f=CreateFrame("Frame",framename,abiSellingFrame,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",423,0-(abiloop*20))
		f:Hide()

		framename="abiSellingBid"..abiloop
		f=CreateFrame("Frame",framename,abiSellingFrame,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",298,0-(abiloop*20))
		f:Hide()

		framename="abiSellingCheap"..abiloop
		f=CreateFrame("Frame",framename,abiSellingFrame,"AbigailMoneyFrameTemplate")
		f:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",573,0-(abiloop*20))
		f:Hide()

		f=abiSellingFrame:CreateFontString("abiPriceType"..abiloop)
		f:SetPoint("TOPLEFT",abiSellingFrame,"TOPLEFT",563,0-(abiloop*20))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(15)
		f:SetHeight(20)
		f:SetJustifyH("LEFT")
		f:Hide()

		f=_G["abiUC"..abiloop]
		f:Hide()

		f=_G["abiSellingButton"..abiloop]
		f:Hide()
	end

	for abiloop=1,15 do
		f=abiSellingProtectFrame:CreateFontString("abiINF"..abiloop)
		f:SetPoint("TOPLEFT",abiSellingProtectFrame,"TOPLEFT",110,0-(abiloop*20))
		f:SetFontObject(GameFontNormal)
		f:SetWidth(390)
		f:SetHeight(20)
		f:SetJustifyH("LEFT")
		f:SetText("")
		f:Hide()

		f=CreateFrame("CheckButton","abiICF"..abiloop,abiSellingProtectFrame,"UICheckButtonTemplate")
		f:SetPoint("TOPLEFT",abiSellingProtectFrame,"TOPLEFT",50,0-(abiloop*20))
		f:SetWidth(22)
		f:SetHeight(22)
		_G["abiICF"..abiloop]:SetScript("OnEnter",abiEnteredCheckbox)
		_G["abiICF"..abiloop]:SetScript("OnLeave",abiLeftCheckbox)
		_G["abiICF"..abiloop]:SetScript("OnClick",abiProtectClicked)
		f:Hide()
	end
end



function abiSellingMakeHeaders()
	CreateFrame("Button","abiSH1",abiSellingFrame,"AbigailButtonTemplate")
	abiSH1:SetWidth(259)
	abiSH1:SetHeight(20)
	abiSH1:SetPoint("TOPLEFT",AuctionFrame,"TOP",-357,-54)
	abiSH1:SetText("Item Name")
	abiSH1.tooltipText="|cffffff00The auctionable items|nin your bags."

	CreateFrame("Button","abiSH2",abiSellingFrame,"AbigailButtonTemplate")
	abiSH2:SetWidth(130)
	abiSH2:SetHeight(20)
	abiSH2:SetPoint("TOPLEFT",AuctionFrame,"TOP",-101,-54)
	abiSH2:SetText("Start Bid")
	abiSH2.tooltipText="|cffffff00The starting Bid price of your auction."

	CreateFrame("Button","abiSH3",abiSellingFrame,"AbigailButtonTemplate")
	abiSH3:SetWidth(130)
	abiSH3:SetHeight(20)
	abiSH3:SetScript("OnClick",abiRoundBuyout)
	abiSH3:SetPoint("TOPLEFT",AuctionFrame,"TOP",27,-54)
	abiSH3:SetText("Buyout")
	abiSH3.tooltipText="|cffffff00The Buyout price of your auction|n|nClick here to round the prices|nup to the nearest 1 or 10 silver"

	CreateFrame("Button","abiSH4",abiSellingFrame,"AbigailButtonTemplate")
	abiSH4:SetWidth(20)
	abiSH4:SetHeight(20)
	abiSH4:SetPoint("TOPLEFT",AuctionFrame,"TOP",156,-54)
	abiSH4:SetText("?")
	abiSH4.tooltipText="|cffffff00How the price was calculated.|nB - From Buy Prices|nS - From Sold Prices|nL - Lowest History Price|nU - Undercutting other Auctions|nA - Average Price|nM - My current auction|nP - Simple Profit|n7 - 7-Day Low Price"

	CreateFrame("Button","abiSH5",abiSellingFrame,"AbigailButtonTemplate")
	abiSH5:SetWidth(130)
	abiSH5:SetHeight(20)
	abiSH5:SetPoint("TOPLEFT",AuctionFrame,"TOP",174,-54)
	abiSH5:SetText("Snapshot")
	abiSH5.tooltipText="|cffffff00The lowest price currently in the|nauction house for this item"
end



function abiHelp2()

	if abiSearchDone==1 then
		abiSellHelp(2)
	end

end



function abiHelp1()
	abiSellHelp(1)
end



function abiSellingScrollFrameUpdate()

	if abiPopUpShown==1 then
		return
	end

	if #abiSellAllTable~=0 then
		FauxScrollFrame_Update(abiSellingScrollFrame,#abiSellAllTable,12,15)
		-- #abiSellAllTable is max entries, 12 is number of lines, 15 is pixel height of each line
		abiSellTableOffset=FauxScrollFrame_GetOffset(abiSellingScrollFrame)
		abiDisplayTheSellingItems()
		abiSellingScrollFrame:Show()
	end

end



function abiProtectScrollFrameUpdate()

	if abiPopUpShown==1 then
		return
	end

	if #abiProtectList~=0 then
		FauxScrollFrame_Update(abiProtectScrollFrame,#abiProtectList,15,15)
		-- #abiSellAllTable is max entries, 15 is number of lines, 15 is pixel height of each line
		abiProtectListOffset=FauxScrollFrame_GetOffset(abiProtectScrollFrame)
		abiDisplayTheProtectItems()
		abiProtectScrollFrame:Show()
	end

end



function abiSellingSlider1_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "Percentage the Start Bid price is lower than the Buyout price.";
	_G[slider.."Low"]:SetText("1");
	_G[slider.."High"]:SetText("50");
	_G[slider.."Text"]:SetText("10%");
end



function abiSellingSlider2_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "Percentage Adjustment of Buyout Prices.";
	_G[slider.."Low"]:SetText("-90");
	_G[slider.."High"]:SetText("500");
	_G[slider.."Text"]:SetText("0%");
end



function abiSellingSlider3_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "Percentage to undercut cheapest auction by.";
	_G[slider.."Low"]:SetText("1");
	_G[slider.."High"]:SetText("50");
	_G[slider.."Text"]:SetText("10%");
end



function abiSellingSlider1ValueChanged()
	local percent
	local aName
	abiSellingSlider1Text:SetText(math.floor(abiSellingSlider1:GetValue()).."%")
	percent=1-(abiSellingSlider1:GetValue()/100)

	if abiSearchDone==1 then

		for abiloop=1,#abiSellAllTable do
			aName,_,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[abiloop])

			if aName~="This Item Auctioned" then
				abiSellBidPrice[abiloop]=math.floor(abiSellBuyoutPrice[abiloop]*percent)

				if abiSellBidPrice[abiloop]<3 then
					abiSellBidPrice[abiloop]=1
				end

			end

		end

		abiDisplayTheSellingItems()
	end

end



function abiSellingSlider2ValueChanged()
	abiSellingSlider2Text:SetText(math.floor(abiSellingSlider2:GetValue()).."%")

	if abiSearchDone==1 then
		abiDisplayTheSellingItems()
	end

end



function abiSellingSlider3ValueChanged()
	abiSellingSlider3Text:SetText(math.floor(abiSellingSlider3:GetValue()).."%")
end



function abiResetSlider1()
	abiSellingSlider1:SetValue(10)
	abiSellingSlider1Text:SetText("10%")
end



function abiResetSlider2()
	abiSellingSlider2:SetValue(0)
	abiSellingSlider2Text:SetText("0%")
end



function abiResetSlider3()
	abiSellingSlider3:SetValue(10)
	abiSellingSlider3Text:SetText("10%")
end



function abiUnderCutting_OnClick(passed)

	if abiPopUpShown==1 then
		return
	end

	passed=passed+abiSellTableOffset
	local percent3=(100-abiSellingSlider3:GetValue())/100
	
	local _,aCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[passed])

	abiSellDefaultBuy[passed]=math.floor(abiSellCheapestPrice[passed]*percent3)

	abiSellPriceType[passed]="U"
	abiDisplayTheSellingItems()
end



function abiSellingTimeButtonClicked()

	if abiPopUpShown==1 then
		return
	end

	abiDuration=abiDuration+1

	if abiDuration==4 then
		abiDuration=1
	end

	abiSellingTimeButton:SetText(abiDurTable[abiDuration])
	abiUpdateSimpleProfits()
	abiDisplayTheSellingItems()
end



function abiRoundBuyout()

	if abiPopUpShown==1 or #abiSellAllTable==0 then
		return
	end

	abiRoundingPrice=1-abiRoundingPrice
	abiDisplayTheSellingItems()
end



function abiSellingFrameUpdate(self,elapsed)

	if abiDoingARead==1 then
		abiSellFrameHelp:SetText("|cffffffffFound AH Prices for item "..abiReadWhichItem.." / "..#abiSellAllTable)
		abiActuallyReadTheItem(abiReadWhichItem)
	end

	if abiDoingARead==2 then
		abiSellFrameHelp:SetText("|cffffffffFound all AH Prices for items in bags.")
		abiDoingARead=0
	end
end


function abiSellingButton_OnClick(passed,button)

	if abiPopUpShown==1 then
		return
	end

	GameTooltip:FadeOut()
	
	if button=="RightButton" then
		-- toggle the stack / item button
		abiSellingAHTypeButtonClicked()

		-- redisplay the tooltip
		abiSellButton_OnEnter(passed)

		return

	end

	abiPassedValue=passed
	-- need buyout price, bid price, stack size, num stacks, duration
	local abiSelling=passed+abiSellTableOffset
	local abiSellCount
	_,abiSellCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[abiSelling])

-- Put in checks so as to limit the number of auctions from one stack
-- ie if stack >9 and <20, display message saying it will result in xx auctions
-- if stack>20, don't allow xx auctions.

	if abiAHType==2 or abiSellCount<10 then
		abiCreateTheAuctions(abiPassedValue)
		return
	end

	if abiSellCount>20 then
		abiPopUpShown=1
		AuctionFrame:SetAlpha(0.5)
		StaticPopup_Show("abiStackTooBig")
		return
	end

	AuctionFrame:SetAlpha(0.5)
	abiPopUpShown=1
	StaticPopup_Show("abiStackCheck",abiSellCount)

end



StaticPopupDialogs["abiStackTooBig"]={
	text="This will result in over 20 auctions.|nPlease adjust Stack Sizes.",
	button1="Ok",

	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
		abiDisplayTheSellingItems()
		abiPopUpShown=0
	end,

	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiStackCheck"]={
	text="Number of Auctions to be created :|n%s",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		abiCreateTheAuctions(abiPassedValue)
	end,

	OnCancel = function(self)
		abiDisplayTheSellingItems()
	end,

	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
		abiPopUpShown=0
	end,

	showAlert = 1,
	timeout=0,
}



function abiCreateTheAuctions(passed)
	-- need buyout price, bid price, stack size, num stacks, duration
	local abiSelling=passed+abiSellTableOffset
	local abiSellName,abiSellCount,abiSellBag,abiSellSlot,abiSellLink
	local abiAuctionStackSize
	local abiAuctionNumStacks
	local t1,t2,t3,abiDeposit
	local abiIsAuctionOk=0

	abiSellName,abiSellCount,abiSellBag,abiSellSlot,abiSellLink,_=abiDecodeSellAllTable(abiSellAllTable[abiSelling])

	-- get item onto cursor
	ClearCursor()
	PickupContainerItem(abiSellBag,abiSellSlot)

	-- Set the duration
	-- This is done and stored in abiDuration as 1,2 or 3
	AuctionFrameAuctions.duration=abiDuration

	-- Set Stack Size - if needed
	-- "Per Unit" - abiAHType==1
	-- "Per Stack" - abiAHType==2
	abiAuctionStackSize=1

	if abiAHType==2 then
		abiAuctionStackSize=abiSellCount
	end

	AuctionsStackSizeEntry:SetText(abiAuctionStackSize)


	-- Set Number of Stacks - if needed
	abiAuctionNumStacks=1

	if abiAHType==1 then
		abiAuctionNumStacks=abiSellCount
		AuctionsNumStacksEntry:SetText(abiSellCount)

		abiAuctionBuy=abiGetBuyoutPrice(abiSelling,1)
		abiAuctionBid=abiGetBidPrice(abiAuctionBuy)

	else
		AuctionsNumStacksEntry:SetText(1)

		abiAuctionBuy=abiGetBuyoutPrice(abiSelling,abiSellCount)
		abiAuctionBid=abiGetBidPrice(abiAuctionBuy)

	end



	-- put Starting Bid price into Starting Price slot
	MoneyInputFrame_SetCopper(StartPrice, abiAuctionBid)


	-- put Buyout Price into Buyout Price Slot
	MoneyInputFrame_SetCopper(BuyoutPrice, abiAuctionBuy)

	t1,t2,t3=GetCursorInfo()

	if t1~="item" then
		print("Bag contents have changed. Please do another Read Bags.")
		ClearCursor()
		return
	end

	t3=abiDecodeItemLink(t3)

	if string.sub(t3,1,#abiSellName)~=abiSellName then
		print("Bag contents have changed. Please do another Read Bags.")
		ClearCursor()
		return
	end

	-- put item into Auction Item Slot
	ClickAuctionSellItemButton()

	-- create the auction.

	StartAuction(abiAuctionBid,abiAuctionBuy,abiDuration,abiAuctionStackSize,abiAuctionNumStacks)
	print(abiAuctionNumStacks.." x Auction(s) Created for : "..abiSellName)
	abiSellAllTable[abiSelling]="This Item Auctioned%1%0%0%"..abiSellLink.."%0"
	abiPriceIndex[abiRealm]["This Item Auctioned"]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for 'This Item Auctioned'
	abiCurrentAuctions["This Item Auctioned"]=abiNilLink.."%0%0%0%0%0:0%0:0%0:0%0:0%0%0:0%0:0%x%0000000001*1" -- record for 'This Item Auctioned'

	abiSellDefaultBuy[abiSelling]=0
	abiSellBuyoutPrice[abiSelling]=0
	abiSellBidPrice[abiSelling]=0
	abiSellCheapestPrice[abiSelling]=0
	abiDisplayTheSellingItems()

end



function abiSellingFrame_OnEvent(frame,event,arg1,arg2,...)
	local p,t
	-- this event to show stack-size prices on small tooltip

	if event=="MODIFIER_STATE_CHANGED" and (arg1=="LSHIFT" or arg1=="RSHIFT") then
		local f,n
		f=GetMouseFocus()

		if f~=nil then

			n=f:GetName()

			if string.sub(n,1,19)~="abiSellMessageFrame" then
				return
			end

			p=string.sub(n,20)
			p=tonumber(p)
			t=1

			if arg2==0 then
				t = 0
			end

			abiSellMessageFrame_OnEnter(p,t)

		end

	end

end



function abiSellingProtectButtonClicked()
	abiProtected=1
	local n,q,i

	-- disable all buttons on main Selling Screen
	abiSellingAHTypeButton:Disable()
	abiSellingResetButton:Disable()
	abiSellingProtectButton:Disable()
	abiSellingTimeButton:Disable()
	abiSellingSearchButton:Disable()
	abiSimpleProfitButton:Disable()
	abiRecentPricesButton:Disable()

	-- fade the selling screen
	abiHideSellingFrame()

	-- show the Protect Screen
	abiSellingProtectFrame:Show()
	abiSellingProtectFrame:SetAlpha(1)

	-- get the items for the Protect list
	abiProtectList=table.wipe(abiProtectList) --item name % item level % Protected (1=yes, 0=no)

	for abiloop=1,#abiProtectTable do
		abiProtectList[abiloop]=abiProtectTable[abiloop]
	end

	for abiloop=1,#abiSellAllTable do
		n,_,_,_,_,q=strsplit("%",abiSellAllTable[abiloop])
		if abiAlreadyInProtectList(n,q)==0 then
			abiProtectList[#abiProtectList+1]=n.."%"..q.."%0"
		end
	end
	abiProtectScrollFrameUpdate()

	--now display the Protect list
	abiDisplayTheProtectItems()
	abiSellHelp(12)
end



function abiAlreadyInProtectList(name,quality)
	local tempname,tempquality

	for abiloop=1,#abiProtectList do
		tempname,tempquality,_=strsplit("%",abiProtectList[abiloop])

		if tempname==name and tempquality==quality then
			return 1
		end

	end

	return 0
end



function abiIsItProtected(name,quality)
	local tempname,tempquality

	for abiloop=1,#abiProtectTable do
		tempname,tempquality,_=strsplit("%",abiProtectTable[abiloop])

		if tempname==name and tonumber(tempquality)==tonumber(quality) then
			return 1
		end

	end

	return 0
end



function abiDisplayTheProtectItems()
	local abiStart
	local abiFinish
	local abiOneToFifteen
	local abiN,abiQ,abiI

	for abiloop=1,15 do
		_G["abiINF"..abiloop]:SetText("empty")
		_G["abiINF"..abiloop]:Show()
		_G["abiICF"..abiloop]:Show()
	end

	abiStart=1+abiProtectListOffset
	abiFinish=15+abiProtectListOffset

	if abiFinish>#abiProtectList then
		abiFinish=#abiProtectList
		abiStart=abiFinish-14
	end

	if abiStart<1 then
		abiStart=1
	end

	if abiStart<=abiFinish then

		for abiloop=abiStart,abiFinish do
			abiOneToFifteen=abiloop-abiStart+1
			abiN,abiQ,abiI=strsplit("%",abiProtectList[abiloop])

			_G["abiINF"..abiOneToFifteen]:SetTextColor(1,0.9,0,0.9)
			_G["abiINF"..abiOneToFifteen]:SetFontObject("GameFontNormal")
			_G["abiINF"..abiOneToFifteen]:SetText(abiN.." ("..abiQ..")")

			if abiI=="1" then
				_G["abiICF"..abiOneToFifteen]:SetChecked(1)
			else
				_G["abiICF"..abiOneToFifteen]:SetChecked(0)
			end

		end
	end
end



function abiHideSellingFrame()
	abiSH1:Hide()
	abiSH2:Hide()
	abiSH3:Hide()
	abiSH4:Hide()
	abiSH5:Hide()
	abiSellingAHTypeButton:Hide()
	abiSellingScrollFrame:Hide()
	abiSellingBottomFrame:Hide()
	abiSellingTimeButton:Hide()
	abiSellingSearchButton:Hide()

	for abiloop=1,12 do
		_G["abiSellingName"..abiloop]:Hide()
		_G["abiSellingBuy"..abiloop]:Hide()
		_G["abiSellingBid"..abiloop]:Hide()
		_G["abiSellingCheap"..abiloop]:Hide()
		_G["abiPriceType"..abiloop]:Hide()
		_G["abiUC"..abiloop]:Hide()
		_G["abiSellingButton"..abiloop]:Hide()
	end

	abiMoneyEarnedFrame:SetAlpha(0.4)
	abiMoneySpentFrame:SetAlpha(0.4)
	abiMoneyProfitFrame:SetAlpha(0.4)
end



function abiSellingProtectFinishedButtonClicked()
	--put everything back from selling screen
	local n,q,i
	abiProtected=0
	abiSellingProtectFrame:Hide()
	abiSH1:Show()
	abiSH2:Show()
	abiSH3:Show()
	abiSH4:Show()
	abiSH5:Show()
	abiSellingAHTypeButton:Show()
	abiSellingScrollFrame:Show()
	abiSellingBottomFrame:Show()
	abiSellingTimeButton:Show()
	abiSellingSearchButton:Show()

	for abiloop=1,12 do
		_G["abiSellingName"..abiloop]:Show()
		_G["abiSellingBuy"..abiloop]:Show()
		_G["abiSellingBid"..abiloop]:Show()
		_G["abiSellingCheap"..abiloop]:Show()
		_G["abiPriceType"..abiloop]:Show()
		_G["abiUC"..abiloop]:Show()
		_G["abiSellingButton"..abiloop]:Show()
	end

	abiSellingAHTypeButton:Enable()
	abiSellingResetButton:Enable()
	abiSellingProtectButton:Enable()
	abiSellingTimeButton:Enable()
	abiSellingSearchButton:Enable()
	abiSimpleProfitButton:Enable()
	abiRecentPricesButton:Enable()

	abiProtectTable=table.wipe(abiProtectTable)

	for abiloop=1,#abiProtectList do
		n,q,i=strsplit("%",abiProtectList[abiloop])

		if i=="1" then
			abiProtectTable[#abiProtectTable+1]=abiProtectList[abiloop]
		end

	end

	abiSellingSearchButtonClicked()
	abiMoneyEarnedFrame:SetAlpha(1)
	abiMoneySpentFrame:SetAlpha(1)
	abiMoneyProfitFrame:SetAlpha(1)
end




function abiEnteredCheckbox()
	local f=GetMouseFocus():GetName()
	local n=tonumber(string.sub(f,7))
	_G["abiINF"..n]:SetTextColor(1,1,1,1)
	_G["abiINF"..n]:SetFontObject("GameFontNormalLarge")
end



function abiLeftCheckbox()

	for n=1,15 do
		_G["abiINF"..n]:SetTextColor(1,0.9,0,0.9)
		_G["abiINF"..n]:SetFontObject("GameFontNormal")
	end
end



function abiProtectClicked()
	local abiN,abiQ,abiI
	local f=GetMouseFocus():GetName()
	local n=tonumber(string.sub(f,7))
	abiN,abiQ,abiI=strsplit("%",abiProtectList[n+abiProtectListOffset])

	if abiN=="empty" then
		_G["abiICF"..n]:SetChecked(0)
		return
	end
	
	if _G["abiICF"..n]:GetChecked()==nil then
		abiI="0"
	else
		abiI="1"
	end
	
	abiProtectList[n+abiProtectListOffset]=abiN.."%"..abiQ.."%"..abiI
end



function abiSimpleProfitButtonClicked()
	local percent,aName,aCount
	local abiBhigh1,abiBlow1,abiRbought1
	local abiDeposit,vendor

	for abiloop=1,#abiSellAllTable do

		aName,aCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[abiloop])

		if aName~="This Item Auctioned" and abiPriceIndex[abiRealm][aName]~=nil then
			_,abiBhigh1,abiBlow1,_,_,_,abiRbought1,_,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][aName])
			abiRbought1,_=abiDecodePriceDays(abiRbought1)
			_,_,_,_,_,_,_,_,_,_,Vendor=GetItemInfo(aName)
			
			if Vendor==nil then -- set to min of 1 silver
				Vendor=100
			end
			
			abiDeposit=math.floor((Vendor*abiVendorToDeposit)+0.5)

			if abiDuration==2 then
				abiDeposit=abiDeposit*2
			end

			if abiDuration==3 then
				abiDeposit=abiDeposit*4
			end

			if abiDeposit<100 then
				abiDeposit=100
			end

			if abiRbought1>0 then
				abiSellDefaultBuy[abiloop]=(abiRbought1+abiDeposit)*2
				abiSellPriceType[abiloop]="P"
			end
		end

	end
	abiDisplayTheSellingItems()

end



function abiUpdateSimpleProfits()
	local percent,aName,aCount
	local abiBhigh1,abiBlow1,abiRbought1
	local abiDeposit,vendor

	for abiloop=1,#abiSellAllTable do
		aName,aCount,_,_,_,_=abiDecodeSellAllTable(abiSellAllTable[abiloop])

		if abiSellPriceType[abiloop]=="P" and aName~="This Item Auctioned" and abiPriceIndex[abiRealm][aName]~=nil then

			_,abiBhigh1,abiBlow1,_,_,_,abiRbought1,_,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][aName])
			abiRbought1,_=abiDecodePriceDays(abiRbought1)
			_,_,_,_,_,_,_,_,_,_,Vendor=GetItemInfo(aName)

			abiDeposit=math.floor((Vendor*abiVendorToDeposit)+0.5)

			if abiDuration==2 then
				abiDeposit=abiDeposit*2
			end

			if abiDuration==3 then
				abiDeposit=abiDeposit*4
			end

			if abiDeposit<100 then
				abiDeposit=100
			end

			if abiRbought1>0 then
				abiSellDefaultBuy[abiloop]=(abiRbought1+abiDeposit)*2
				abiSellPriceType[abiloop]="P"
			end
		end

	end
end


function abiRecentPricesButtonClicked()
	abiGetSellingPrices(1)
	abiDisplayTheSellingItems()
end
