-- Shopping page for Abigail 2.30
-- 17/12/13

local abiScrollList1={}
local abiScrollList2={}
local abiHelpText={}
local abiIgnorePricesButtonText={}
local abiMaxButtonText={}
local abiMyFaction,_=UnitFactionGroup("Player")
local abiMax=2
abiHelpText[1]="Items here can be added to the Shopping List"
abiHelpText[2]="Your Shopping List - add/remove items or alter prices"
abiHelpText[3]="General Price History for an Item"
abiHelpText[4]="Options and Price Adjustment"
abiHelpText[6]="Construct a Shopping List of favourite items"

abiMaxButtonText[1]="Max On"
abiMaxButtonText[2]="Max Off"

local abiScrollTableOffset1=0
local abiScrollTableOffset2=0
local abiShoppingTarget=0
local abiRemovingNumber=0
local abiRemovingName=""
local abiShopCosting=1
local abiUsingClasses=1
local abiMessageWait=0



function abiShoppingFrame_OnLoad()
	abiShoppingFrame:Hide()
	abiPartFrame1:SetBackdropBorderColor(1,1,1,0.5)
	abiPartFrame2:SetBackdropBorderColor(1,1,1,0.5)
	abiPartFrame3:SetBackdropBorderColor(1,1,1,0.5)
	abiPartFrame4:SetBackdropBorderColor(1,1,1,0.5)
	abiShopDeleteButton:Disable()
	abiShopSlider1:Disable()

	abiShopResetButton.tooltipText="|cffffff00Reset prices to Sold-Hi."
	abiShopSort.tooltipText="|cffffff00Sort the Shopping List alphabetically."
	abiShopUseClassButton.tooltipText="|cffffff00Use the class selections|nfrom the Main Options screen."
	abiGenerateButton.tooltipText="|cffffff00Show all items that can be|nadded to the Shopping List."
	abiShoppingSearchButton.tooltipText="|cffffff00Search the Snapshot for items|nin the Shopping List."
	abiShopDeleteButton.tooltipText="|cffffff00Delete this item from|nyour Shopping List."
	abiShopDeleteAllButton.tooltipText="|cffffff00Delete all items from|nyour Shopping List."
	abiShoppingMaxButton.tooltipText="|cffffff00Limit similar items by|nMax Same Items slider."
end



function abiCreateScrollList2()
	abiRealm=GetRealmName()..abiMyFaction
	-- this function called from main Abigail file when Shopping tab pressed
	-- abiShoppingList = [Realm][ItemName] = costtype..%..max-spend-value
	abiShoppingTarget=0
	local k,k2,v2
	abiScrollList2=table.wipe(abiScrollList2)

	for k,v in pairs(abiShoppingList) do
		--k is the realm name

		if abiRealm==k then

			for k2,v2 in pairs(abiShoppingList[k]) do
				--k2 is name field, v2 is shopping list price field
				abiScrollList2[#abiScrollList2+1]=k2.."%"..v2
			end

		end

	end

	if #abiScrollList2>0 then

		abiShoppingScroll2Update()
		abiDisplayScroll2Items(#abiScrollList2)

	end

	abiEmptyFrame3()
end



function abiDisplayScroll1Items(passed)

	local abiStart
	local abiFinish
	local abiOneToTen

	abiStart=1+abiScrollTableOffset1
	abiFinish=10+abiScrollTableOffset1

	if abiFinish>passed then
		abiFinish=passed
	end

	if abiStart<=abiFinish then

		for abidisplayloop=abiStart,abiFinish do
			abiOneToTen=abidisplayloop-abiStart+1
			_G["abiShopFrame1String"..abiOneToTen]:SetText(string.sub(abiScrollList1[abidisplayloop],1,35))
		end

	end

end



function abiDisplayScroll2Items(passed)
	local abiStart
	local abiFinish
	local abiOneToTen
	local abitp={}
	local t1,t2,t3,tempprice

	abiStart=1+abiScrollTableOffset2
	abiFinish=10+abiScrollTableOffset2

	if abiFinish>passed then
		abiFinish=passed
	end
	abiRealm=GetRealmName()..abiMyFaction
	
	if abiStart<=abiFinish then

		for abidisplayloop=abiStart,abiFinish do
			abiOneToTen=abidisplayloop-abiStart+1
			t1,t2,t3=strsplit("%",abiScrollList2[abidisplayloop])
			-- t1=name, t2=costtype, t3=percent
			t2=tonumber(t2)
			t3=tonumber(t3)
			_,abitp[1],abitp[2],abitp[3],abitp[4],_,_,_,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][t1])

			tempprice=abitp[t2]+(((t3-100)/100)*abitp[t2])
			
			_G["abiShopFrame2String"..abiOneToTen]:SetText(string.sub(t1,1,30))
			_G["abiShopFrame2String"..abiOneToTen]:SetTextColor(1,0.9,0,0.9)
			_G["abiShopFrame2Cash"..abiOneToTen]:SetText(abiCreatePriceStringIcons(tempprice,0))
		end

	end

end



function abiShopMessageFrame1_OnLeave(passed)

	if abiShoppingTarget==0 then
		_G["abiShopFrame1String"..passed]:SetTextColor(1,0.9,0,0.9)
		_G["abiShopFrame1String"..passed]:SetFontObject("GameFontNormal")
		abiEmptyFrame3()
	end

end



function abiShopMessageFrame2_OnLeave(passed)

	if abiShoppingTarget==0 then
		abiEmptyFrame3()
		_G["abiShopFrame2String"..passed]:SetTextColor(1,0.9,0,0.9)
		_G["abiShopFrame2String"..passed]:SetFontObject("GameFontNormal")
	end

end



function abiShopMessageFrame1_OnEnter(passed)

	if abiScrollTableOffset1~=nil and passed<=#abiScrollList1 and abiShoppingTarget==0 then
		abiRealm=GetRealmName()..abiMyFaction --just make sure
		local abiItemName=abiScrollList1[passed+abiScrollTableOffset1]
		abiLink1,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRsold1,abiRbought1,abiRatio1,abiSeen1,abiTimeStamp,abiRecentHigh,abiRecentLow,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])
		abiFillFrame3(abiItemName,abiBhigh1,abiBlow1,abiShigh1,abiSlow1,abiRatio1,0)
		_G["abiShopFrame1String"..passed]:SetTextColor(1,1,1,1)
		_G["abiShopFrame1String"..passed]:SetFontObject("GameFontNormalLarge")
	end

	abiShowFrameHelp(1)
end



function abiShopMessageFrame2_OnEnter(passed)
	local bhigh,blow,shigh,slow,ratio
	
	if abiScrollTableOffset2~=nil and passed<=#abiScrollList2 and abiShoppingTarget==0 then
		abiRealm=GetRealmName()..abiMyFaction --just make sure
		local abiItemName,abiWhich,abiPercent=strsplit("%",abiScrollList2[passed+abiScrollTableOffset2])
		abiPercent=tonumber(abiPercent)
		_,bhigh,blow,shigh,slow,_,_,ratio,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])
		abiFillFrame3(abiItemName,bhigh,blow,shigh,slow,ratio,abiWhich)
		_G["abiShopFrame2String"..passed]:SetTextColor(1,1,1,1)
		_G["abiShopFrame2String"..passed]:SetFontObject("GameFontNormalLarge")
		abiShopSlider1:SetValue(abiPercent)
		abiShopSlider1Text:SetText("|cff808080"..abiPercent)
	end

	abiShowFrameHelp(2)
end



function abiEmptyFrame3()
	abiShopFrame3ItemNameString:SetText("----------")
	abiShopFrame3Cash1:SetText("----------")
	abiShopFrame3Cash2:SetText("----------")
	abiShopFrame3Cash3:SetText("----------")
	abiShopFrame3Cash4:SetText("----------")
	abiShopFrame3Ratio:SetText("0 sold from 0 auctions")
	abiShopFrame3String1:SetText("|cffffffffBuy-Hi :")
	abiShopFrame3String2:SetText("|cffffffffBuy-Lo :")
	abiShopFrame3String3:SetText("|cffffffffSold-Hi :")
	abiShopFrame3String4:SetText("|cffffffffSold-Lo :")
end



function abiEmptyFrame1()

	for abiloop=1,10 do
		_G["abiShopFrame1String"..abiloop]:SetText("")
	end

end



function abiEmptyFrame2()

	for abiloop=1,10 do
		_G["abiShopFrame2String"..abiloop]:SetText("")
		_G["abiShopFrame2Cash"..abiloop]:SetText("")
	end

end



function abiFillFrame3(item,t1,t2,t3,t4,ratio,which)
	local abiRat1,abiRat2
	abiRat1,abiRat2=abiDecodeRatio(ratio)
	abiShopFrame3ItemNameString:SetText("|cffffffff"..string.sub(item,1,35))

	if t1>0 then
		abiShopFrame3Cash1:SetText(abiCreatePriceStringIcons(t1,0))
	end

	if t2>0 then
		abiShopFrame3Cash2:SetText(abiCreatePriceStringIcons(t2,0))
	end

	if t3>0 then
		abiShopFrame3Cash3:SetText(abiCreatePriceStringIcons(t3,0))
	end

	if t4>0 then
		abiShopFrame3Cash4:SetText(abiCreatePriceStringIcons(t4,0))
	end

	abiShopFrame3Ratio:SetText(abiRat1.." sold from "..abiRat2.." auctions")
	abiShopFrame3String1:SetText("|cffffffffBuy-Hi :")
	abiShopFrame3String2:SetText("|cffffffffBuy-Lo :")
	abiShopFrame3String3:SetText("|cffffffffSold-Hi :")
	abiShopFrame3String4:SetText("|cffffffffSold-Lo :")
	which=tonumber(which)

	if which==1 then
		abiShopFrame3String1:SetText"|cffff4040Buy-Hi :"
	end

	if which==2 then
		abiShopFrame3String2:SetText"|cffff4040Buy-Lo :"
	end

	if which==3 then
		abiShopFrame3String3:SetText"|cffff4040Sold-Hi :"
	end

	if which==4 then
		abiShopFrame3String4:SetText"|cffff4040Sold-Lo :"
	end

end



function abiShopFrame1Click(passed,button)

	if abiShoppingTarget~=0 then
		return
	end

	abiRealm=GetRealmName()..abiMyFaction --just make sure
	local abiItemName,abiNewItem
	local abiItemPrice={}
	local abiList2Name
	local abiInfo
	local temppassed=passed
	passed=passed+abiScrollTableOffset1

	if passed>#abiScrollList1 then
		return
	end

	abiItemName=abiScrollList1[passed]

	if button=="RightButton" then

		_,abiItemPrice[1],abiItemPrice[2],abiItemPrice[3],abiItemPrice[4],_,_,_,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])

		-- see if abiItemName already in scroll list 2
		abiNewItem=1

		for abiloop=1,#abiScrollList2 do
			abiList2Name,_,_=strsplit("%",abiScrollList2[abiloop])

			if abiItemName==abiList2Name then
				abiNewItem=0
			end

		end

		if abiNewItem==1 then
			abiInfo=abiItemName.."%3%50"
			abiShoppingList[abiRealm][abiItemName]="3%50"
			table.insert(abiScrollList2,1,abiInfo)
			abiShoppingScrollFrame2:SetVerticalScroll(0)
			abiShoppingScroll2Update()
			abiDisplayScroll2Items(#abiScrollList2)
			table.remove(abiScrollList1,passed)
			abiEmptyFrame1()
			abiShoppingScroll1Update()
			abiDisplayScroll1Items(#abiScrollList1)
			abiEmptyFrame3()
			abiShopMessageFrame1_OnEnter(temppassed)
		end

	end

	if button=="LeftButton" then

		if IsShiftKeyDown()==1 then
			abiItemName=abiShortenName(abiItemName)
		end

		--Put the item name into the BrowseName field of main AH window
		BrowseName:SetText(abiItemName)

		--Now put it in Search field of Adjusting Screen
		abiAdjBrowseName:SetText(abiItemName)


		if (IsAddOnLoaded("Auctionator")) then
			Atr_Search_Box:SetText(abiItemName)
		end

		return
	end

end



function abiGenerateButtonClicked()

	if abiShoppingTarget==0 then
		abiRealm=GetRealmName()..abiMyFaction
		local k,k2,v2,rat1,rat2
		abiScrollList1=table.wipe(abiScrollList1)

		for k,v in pairs(abiPriceIndex) do
		--k is the realm name

			if abiRealm==k then

				for k2,v2 in pairs(abiPriceIndex[k]) do
					--k2 is name field, v2 is price index field
					_,abiBhigh1,_,abiShigh1,_,_,_,_,_,_,_,_,_,_=strsplit("%",v2)
					abiBhigh1=tonumber(abiBhigh1)
					abiShigh1=tonumber(abiShigh1)

-- shopping list to be made from just those items that have been sucessfully sold.
					if abiShigh1>0 and abiShoppingList[abiRealm][k2]==nil then
						abiScrollList1[#abiScrollList1+1]=k2
					end

				end

			end

		end

		table.sort(abiScrollList1,abiLowHigh)
		abiShoppingScroll1Update()
		abiDisplayScroll1Items(#abiScrollList1)

		if #abiScrollList1==0 then
			abiShopFrame1Help3:SetText("|cffffffffNo items found")
			abiMessageWait=time()+3
		else
			k=" item"
			if #abiScrollList1>1 then
				k=" items"
			end
			abiShopFrame1Help3:SetText("|cffffffff"..#abiScrollList1..k.." can be added to Shopping List")
			abiMessageWait=time()+3
		end

	end

end



function abiShoppingSearchButton_OnClick()
	local abiShopBargains={}
	if abiShoppingTarget~=0 or #abiScrollList2==0 then
		return
	end

	local t1,t2,t3
	local abiType
	local abiItemPrice={}
	local abiSearchPrice
	abiShopBargains=table.wipe(abiShopBargains)

	for abiloop=1,#abiAHImage do
		abiImageName,abiImageCount,abiImagePrice,abiItemLink,abiImageTime,abiImageBid=abiDecodeImage(abiAHImage[abiloop])

		abiImagePrice=math.floor(abiImagePrice/abiImageCount)

		_,_,_,_,_,abiType,_,_,_,_=GetItemInfo(abiItemLink)

		_,abiItemPrice[1],abiItemPrice[2],abiItemPrice[3],abiItemPrice[4],_,_,_,_,_,_,_,abiPriceHistory=abiDecodeIndex(abiPriceIndex[abiRealm][abiImageName])

		abiDecodePriceHistory(abiPriceHistory)
		abiItemAverage=abiFindAveragePrice()

		if (abiCheckTheType(abiType)==1 and abiUsingClasses==1) or abiUsingClasses==0 then

			for abiloop2=1,#abiScrollList2 do
				t1,t2,t3=strsplit("%",abiScrollList2[abiloop2])
				-- t1=name, t2=costtype, t3=percentprice

				t2=tonumber(t2)
				t3=tonumber(t3)
				abiSearchPrice=abiItemPrice[t2]+(((t3-100)/100)*abiItemPrice[t2])

				if t1==abiImageName and (abiImagePrice<=abiSearchPrice) and (abiImagePrice<abiItemAverage) then
					if abiStackUnitPrices==1 then
							abiShopBargains[#abiShopBargains+1]=abiMakeFullPrice(abiItemAverage-abiImagePrice).."%"..tostring(abiloop)
					else
abiShopBargains[#abiShopBargains+1]=abiMakeFullPrice((abiItemAverage-abiImagePrice)*abiImageCount).."%"..tostring(abiloop)
					end

				end

			end

		end

	end

	if #abiShopBargains>0 then
		abiTableOffset=0 -- resets the scroll on the Bargains/Deals screen
		abiScrollFrame1:SetVerticalScroll(0)
		abiBargains=abiShopBargains

		table.sort(abiBargains,abiHighLow)

		if abiMax==1 then
			abiSB=table.wipe(abiSB)
			abiCheckMaxSameValue()
		end

		t1="|cffffffff"..#abiBargains.." matching auction"

		if #abiBargains>1 then
			t1=t1.."s"
		end

		t1=t1.." found"

		abiShopFrame1Help3:SetText(t1)
		abiMessageWait=time()+3

		abiLastSearchText="Shopping Search"
		abiLastSearch="Shopping"
		abiBargainsString:SetText("Shopping List Items Found : "..#abiBargains)

	else
		abiShopFrame1Help3:SetText("|cffffffffNo matching auctions found")
		abiMessageWait=time()+3
	end
end



function abiShoppingScroll1Update()

	if #abiScrollList1~=0 then
		FauxScrollFrame_Update(abiShoppingScrollFrame1,#abiScrollList1,10,15)
		-- #abiScrollList1 is max entries, 10 is number of lines, 15 is pixel height of each line
		abiScrollTableOffset1=FauxScrollFrame_GetOffset(abiShoppingScrollFrame1)
		abiDisplayScroll1Items(#abiScrollList1)
		abiShoppingScrollFrame1:Show()
	end

end



function abiShoppingScroll2Update()

	if abiShoppingTarget==0 then
		for abiloop=1,10 do
			_G["abiShopFrame2String"..abiloop]:SetFontObject("GameFontNormal")
		end

		if #abiScrollList2~=0 then
			FauxScrollFrame_Update(abiShoppingScrollFrame2,#abiScrollList2,10,15)
			-- #abiScrollList2 is max entries, 10 is number of lines, 15 is pixel height of each line
			abiScrollTableOffset2=FauxScrollFrame_GetOffset(abiShoppingScrollFrame2)
			abiDisplayScroll2Items(#abiScrollList2)
			abiShoppingScrollFrame2:Show()
		end
	end
end



function abiShopFrame2Click(passed,button)
	local itemname,itempercent
	local t1,t2,t3
	if abiShoppingTarget~=0 and button=="LeftButton" then
		return
	end
	if passed>#abiScrollList2 or abiShoppingTarget~=0 then
		abiShopSort:Enable()
		abiShopUseClassButton:Enable()
		abiShopResetButton:Enable()
		abiShopDeleteAllButton:Enable()
		abiShopDeleteButton:Disable()
		abiShopSlider1:Disable()
		abiShopSlider1Text:SetText("|cff808080"..math.floor(abiShopSlider1:GetValue()))

		if abiShoppingTarget~=0 then
			_G["abiShopFrame2String"..abiShoppingTarget]:SetTextColor(1,0.9,0,0.9)
			_G["abiShopFrame2String"..abiShoppingTarget]:SetFontObject("GameFontNormal")
		end
		
		if passed<=#abiScrollList2 then
			_G["abiShopFrame2String"..passed]:SetTextColor(1,1,1,1)
			_G["abiShopFrame2String"..passed]:SetFontObject("GameFontNormalLarge")
		end

		abiShoppingTarget=0
		abiShopMessageFrame2_OnEnter(passed)
		abiHelpText[2]="Your Shopping List - add/remove items or alter prices"
		abiShowFrameHelp(2)
		return
	end

	if button=="RightButton" then
		abiShopSort:Disable()
		abiShopUseClassButton:Disable()
		abiShopResetButton:Disable()
		abiShopDeleteAllButton:Disable()

		abiShopDeleteButton:Enable()
		abiShopSlider1:Enable()
		abiShopSlider1Text:SetText("|cffffffff"..math.floor(abiShopSlider1:GetValue()))

		abiShoppingTarget=passed
		itemname,_,itempercent=strsplit("%",abiScrollList2[passed+abiScrollTableOffset2])
		abiShopSlider1:SetValue(tonumber(itempercent))
		abiShopSlider1Text:SetText(tonumber(itempercent))
		abiHelpText[2]="Adjust with slider or delete price - right-click to finish"
		abiShowFrameHelp(2)
		return
	end

	-- gets here if LeftButton pressed
	abiShoppingTarget=passed
	t1,t2,t3=strsplit("%",abiScrollList2[passed+abiScrollTableOffset2])
	abiShopCosting=tonumber(t2)
	abiShopSlider1:SetValue(t3)
	abiShopSlider1Text:SetText("|cff808080"..t3)
	abiRealm=GetRealmName()..abiMyFaction
	abiShopCosting=abiShopCosting+1

	if abiShopCosting==5 then
		abiShopCosting=1
	end

	local abiItemPrice={}
	local abiItemName
	local abiNewPrice
	abiItemName,_,_=strsplit("%",abiScrollList2[abiShoppingTarget+abiScrollTableOffset2])

	_,abiItemPrice[1],abiItemPrice[2],abiItemPrice[3],abiItemPrice[4],_,_,abiRatio1,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][abiItemName])

	if abiItemPrice[1]==0 and abiShopCosting==1 then
		abiShopCosting=2
	end
		
	if abiItemPrice[2]==0 and abiShopCosting==2 then
		abiShopCosting=3
	end

	abiNewPrice=abiItemPrice[abiShopCosting]+(((math.floor(abiShopSlider1:GetValue())-100)/100)*abiItemPrice[abiShopCosting])

	if abiNewPrice<1 then
		abiNewPrice=1
	end

	abiScrollList2[abiShoppingTarget+abiScrollTableOffset2]=abiItemName.."%"..tostring(abiShopCosting).."%"..tostring(math.floor(abiShopSlider1:GetValue()))
	_G["abiShopFrame2Cash"..abiShoppingTarget]:SetText(abiCreatePriceStringIcons(abiNewPrice,0))
	abiShoppingList[abiRealm][abiItemName]=tostring(abiShopCosting).."%"..tostring(math.floor(abiShopSlider1:GetValue()))

	abiFillFrame3(abiItemName,abiItemPrice[1],abiItemPrice[2],abiItemPrice[3],abiItemPrice[4],abiRatio1,abiShopCosting)
	abiShoppingTarget=0

	return
end



StaticPopupDialogs["abiRemoveShoppingListConfirm"]={
	text="Remove %s|nfrom the shopping list?",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		table.remove(abiScrollList2,abiRemovingNumber)
		abiShoppingList[abiRealm][abiRemovingName]=nil
		abiRemovingNumber=0
		abiRemovingName=""
	end,

	OnCancel = function(self)
		abiShopDeleteButton:Disable()
		abiShopSlider1:Disable()
		abiShopSlider1Text:SetText("|cff808080"..math.floor(abiShopSlider1:GetValue()))

	end,

	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
		abiShopDeleteButton:Disable()
		abiShopSlider1:Disable()
		_G["abiShopFrame2String"..abiShoppingTarget]:SetTextColor(1,0.9,0,0.9)
		_G["abiShopFrame2String"..abiShoppingTarget]:SetFontObject("GameFontNormal")
		abiShoppingTarget=0
		abiEmptyFrame3()
		abiShoppingScroll2Update()
		abiEmptyFrame2()
		abiDisplayScroll2Items(#abiScrollList2)
		abiShopSort:Enable()
		abiShopUseClassButton:Enable()
		abiShopResetButton:Enable()
		abiShopDeleteAllButton:Enable()

	end,

	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiResetPricesConfirm"]={
	text="Warning!|n|nThis will reset all item prices|nto their highest selling price|nand all percentages to 50",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		abiDoTheReset()
		abiDisplayScroll2Items(#abiScrollList2)
	end,

	OnCancel = function(self)
	end,

	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
		abiShopSort:Enable()
		abiShopUseClassButton:Enable()
		abiShopResetButton:Enable()
		abiShopDeleteAllButton:Enable()
	end,

	showAlert = 1,
	timeout=0,
}



StaticPopupDialogs["abiDeleteAllConfirm"]={
	text="Warning!|n|nThis will delete all items|nfrom your shopping list|n|nThis Cannot Be Undone!",
	button1="Accept",
	button2="Cancel",

	OnAccept = function(self)
		abiDoTheDeleteAll()
		abiDisplayScroll2Items(#abiScrollList2)
	end,

	OnCancel = function(self)
	end,

	OnHide = function(self)
		AuctionFrame:SetAlpha(1)
		abiShopSort:Enable()
		abiShopUseClassButton:Enable()
		abiShopResetButton:Enable()
		abiShopDeleteAllButton:Enable()

	end,

	showAlert = 1,
	timeout=0,
}



function abiShowFrameHelp(passed)

	if time()>abiMessageWait then
		abiShopFrame1Help3:SetText("|cffffffff"..abiHelpText[passed])
	end
end



function abiShopSlider1_OnLoad(slider)
	local sl=_G[slider]
	sl.tooltipText = "Adjust price for the selected item";
	_G[slider.."Low"]:SetText("");
	_G[slider.."High"]:SetText("");
	_G[slider.."Text"]:SetText("|cff80808050");
end



function abiSliderValueChanged()
	abiRealm=GetRealmName()..abiMyFaction
	local abiWhich,abiValue
	local t1,t2
	local abiNewPrice
	local abiItemPrice={}
	abiShopSlider1Text:SetText(math.floor(abiShopSlider1:GetValue()))

	if abiShoppingTarget==0 then
		return
	end

	abiWhich=abiShoppingTarget+abiScrollTableOffset2
	abiValue=math.floor(abiShopSlider1:GetValue())
	t1,t2,_=strsplit("%",abiScrollList2[abiWhich])
	t2=tonumber(t2)

	_,abiItemPrice[1],abiItemPrice[2],abiItemPrice[3],abiItemPrice[4],_,_,_,_,_,_,_,_=abiDecodeIndex(abiPriceIndex[abiRealm][t1])

	abiNewPrice=abiItemPrice[t2]+(((abiValue-100)/100)*abiItemPrice[t2])

	if abiNewPrice<1 then
		abiNewPrice=1
	end

	abiScrollList2[abiWhich]=t1.."%"..tostring(t2).."%"..tostring(abiValue)
	_G["abiShopFrame2Cash"..abiShoppingTarget]:SetText(abiCreatePriceStringIcons(abiNewPrice,0))
	abiShoppingList[abiRealm][t1]=tostring(t2).."%"..tostring(abiValue)
end



function abiShopUseClassChange()
	abiUsingClasses=1-abiUsingClasses

	if abiUsingClasses==1 then
		abiShopUseClassButton:SetText("Use Classes")
	else
		abiShopUseClassButton:SetText("Don't Use Classes")
	end

end



function abiSortShoppingList()

	if abiShoppingTarget==0 then
		table.sort(abiScrollList2,abiLowHigh)
		abiDisplayScroll2Items(#abiScrollList2)
	end

end



function abiShopDeleteButtonPressed()
	AuctionFrame:SetAlpha(0.5)
	abiRemovingNumber=abiShoppingTarget+abiScrollTableOffset2
	itemname,_,_=strsplit("%",abiScrollList2[abiShoppingTarget+abiScrollTableOffset2])
	abiRemovingName=itemname
	StaticPopup_Show("abiRemoveShoppingListConfirm",itemname)

end



function abiShopResetButtonClicked()
	abiShopSort:Disable()
	abiShopUseClassButton:Disable()
	abiShopResetButton:Disable()
	abiShopDeleteAllButton:Disable()
	AuctionFrame:SetAlpha(0.5)
	StaticPopup_Show("abiResetPricesConfirm")
end



function abiDoTheReset()
	abiRealm=GetRealmName()..abiMyFaction -- just make sure
	for k,v in pairs(abiShoppingList) do
		--k is the realm name

		if abiRealm==k then

			for k2,v2 in pairs(abiShoppingList[k]) do
				--k2 is name field, v2 is shopping list price field
				abiShoppingList[k][k2]="3%50"
			end

			abiCreateScrollList2()
		end
	end
end



function abiShopDeleteAllButtonClicked()
	AuctionFrame:SetAlpha(0.5)
	abiShopSort:Disable()
	abiShopUseClassButton:Disable()
	abiShopResetButton:Disable()
	abiShopDeleteAllButton:Disable()
	StaticPopup_Show("abiDeleteAllConfirm")
end



function abiDoTheDeleteAll()
	abiRealm=GetRealmName()..abiMyFaction -- just make sure
	abiShoppingList[abiRealm]=table.wipe(abiShoppingList[abiRealm])
	abiCreateScrollList2()
	abiEmptyFrame2()

end


function abiShoppingMaxButton_OnClick()
	abiMax=3-abiMax
	abiShoppingMaxButton:SetText(abiMaxButtonText[abiMax])
end
